-- *******************************************************
--  KOHA MARC 21 STANDARD DEFAULT BIBLIOGRAPHIC FRAMEWORK 
--                                                        
--                  PRETEST VERSION 0.2.1                 
--                       2006-09-19                       
--                                                        
--  original default requiring greater user customisation 
--               created by a few Koha Hands              
--                 guided by Paul POULAIN                 
--                                                        
--       revised and greatly enlarged to completion,      
--            well not quite complete yet today           
--        but close enough for someone to have use,       
--                   by thd for LibLime                   
-- *******************************************************



-- ******************************************************
-- KOHA RECORD AND HOLDINGS MANAGEMENT FIELDS/SUBFIELDS. 
-- ******************************************************

-- These ought to be adjusted for different less conflicting and more 
-- rationally chosen fields and subfields but I had left that for last. 

-- ADJUST ME
-- Use values from your dump of marc_tag_structure and marc_subfield_structure 
-- to provide support for your Koha database.


-- ******************************************************

-- Original Record ID Field/Subfields 


-- INSERT INTO `marc_tag_structure` VALUES ('090', 'KOHA DATA', 'KOHA DATA', 1, 0, '', ''); 

-- INSERT INTO marc_subfield_structure VALUES ('090', 'a', 'Koha Itemtype (NR)', 'Koha Itemtype (NR)', 0, 0, NULL, -1, NULL, NULL, '', NULL, '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('090', 'b', 'Koha Dewey Subclass (NR)', 'Koha Dewey Subclass (NR)', 0, 0, NULL, -1, NULL, NULL, '', NULL, '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('090', 'c', 'Koha biblionumber (NR)', 'Koha biblionumber (NR)', 0, 0, 'biblio.biblionumber', -1, NULL, NULL, '', NULL, '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('090', 'd', 'Koha biblioitemnumber (NR)', 'Koha biblioitemnumber (NR)', 0, 0, 'biblioitems.biblioitemnumber', -1, NULL, NULL, '', NULL, '', NULL, NULL); 


-- Current Record ID Field/Subfields 


INSERT INTO `marc_tag_structure` VALUES ('090', 'SYSTEM CONTROL NUMBERS (KOHA)', 'SYSTEM CONTROL NUMBERS (KOHA)', 1, 0, '', '');

INSERT INTO `marc_subfield_structure` VALUES ('090', 'a', 'Item type [OBSOLETE]', 'Item type [OBSOLETE]', 0, 0, NULL, -1, NULL, NULL, '', NULL, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('090', 'b', 'Koha Dewey Subclass [OBSOLETE]', 'Koha Dewey Subclass [OBSOLETE]', 0, 0, NULL, 0, NULL, NULL, '', NULL, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('090', 'c', 'Koha biblionumber', 'Koha biblionumber', 0, 0, 'biblio.biblionumber', -1, NULL, NULL, '', NULL, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('090', 'd', 'Koha biblioitemnumber', 'Koha biblioitemnumber', 0, 0, 'biblioitems.biblioitemnumber', -1, NULL, NULL, '', NULL, -5, '', '', '');


-- ******************************************************

-- Original primary biblioitems Field/Subfields 


-- INSERT INTO `marc_tag_structure` VALUES ('942', 'Biblioitem information', 'General classification', 0, 0, '', ''); 

-- INSERT INTO marc_subfield_structure VALUES ('942', 'a', 'Institution code', 'Institution code', 0, 0, '', 5, '', '', '', NULL, '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('942', 'c', 'item type', 'item type', 0, 0, 'biblioitems.itemtype', 5, 'itemtypes', '', '', NULL, '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('942', 'k', 'dewey', 'dewey', 0, 0, 'biblioitems.classification', 5, '', '', '', NULL, '', NULL, NULL); 


-- Current primary biblioitems Field/Subfields 


INSERT INTO `marc_tag_structure` VALUES ('942', 'ADDED ENTRY ELEMENTS (KOHA)', 'ADDED ENTRY ELEMENTS (KOHA)', 0, 0, '', '');

INSERT INTO `marc_subfield_structure` VALUES ('942', 'a', 'Institution code [OBSOLETE]', 'Institution code [OBSOLETE]', 0, 0, '', 9, '', '', '', NULL, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('942', 'c', 'Item type', 'Item type', 0, 1, 'biblioitems.itemtype', 9, 'itemtypes', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('942', 'j', 'Location (call number prefix code)', 'Location (call number prefix code)', 0, 0, 'biblioitems.classification', 9, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('942', 'k', 'Classification base (DDC to decimal or LCC letter class padded after single letter classes with trailing 0', 'Classification base', 0, 0, 'biblioitems.dewey', 9, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('942', 'l', 'Classification subclass (DDC after decimal or LCC number after letters', 'Classification subclass', 0, 0, 'biblioitems.subclass', 9, '', '', '', NULL, 0, '', '', '');


-- ******************************************************

-- Original items Field/Subfields 


-- INSERT INTO `marc_tag_structure` VALUES ('952', 'ITEM INFORMATION', 'ITEM INFORMATION', 1, 0, '', ''); 

-- INSERT INTO marc_subfield_structure VALUES ('952', 'b', 'homebranch', 'homebranch', 0, 0, 'items.homebranch', 10, 'branches', '', '', '', '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('952', 'd', 'holdingbranch', 'holdingbranch', 0, 0, 'items.holdingbranch', 10, 'branches', '', '', '\'952b\'', '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('952', 'p', 'barcode', 'barcode', 0, 1, 'items.barcode', 10, '', '', '', '', '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('952', 'r', 'price', 'price', 0, 0, 'items.replacementprice', 10, '', '', '', '', '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('952', 'v', 'dateaccessioned', 'dateaccessioned', 0, 0, 'items.dateaccessioned', 10, '', '', '', '', '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('952', 'y', 'notforloan', 'notforloan', 0, 0, 'items.notforloan', 10, '', '', '', '', '', NULL, NULL); 
-- INSERT INTO marc_subfield_structure VALUES ('952', 'u', 'itemnumber', 'itemnumber', 0, 0, 'items.itemnumber', -1, '', '', '', '', '', NULL, NULL); 



-- Recommended items Field/Subfields 


-- INSERT INTO `marc_tag_structure` VALUES ('95k', 'LOCATION AND ITEM INFORMATION (KOHA)', 'LOCATION AND ITEM INFORMATION (KOHA)', 1, 0, '', '');

-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '0', 'Item status (withdrawn) (similar to 876-8 $j)', 'Item status (withdrawn)', 0, 0, 'items.withdrawn', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '1', 'Item status (lost) (similar to 876-8 $j)', 'Item status (lost)', 0, 0, 'items.itemlost', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '2', 'Source of classification or shelving scheme (similar to 852 $2)', 'Source of classification or shelving scheme', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '3', 'Materials specified (similar to 852, 876-8 $3)', 'Materials specified', 0, 0, '', 10, '', '', '', NULL, -1, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '4', 'Use restrictions (similar to 506 $a, 876-8 $h)', 'Use restrictions', 0, 0, 'items.restricted', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '6', 'Linkage (similar to 852, 876-8 $6)', 'Linkage', 0, 0, '', 10, '', '', '', NULL, -6, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '8', 'Sequence number (similar to 852, 876-8 $8)', 'Sequence number', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', '9', 'Koha itemnumber (autogenerated similar to 852, 876-8 $3 $8 $t combined)', 'Koha itemnumber', 0, 0, 'items.itemnumber', -1, '', '', '', 0, -5, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'a', 'Location (homebranch) (similar to 852 $a)', 'Location (homebranch)', 0, 0, 'items.homebranch', 10, 'branches', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'b', 'Sublocation or collection (holdingbranch) (similar to 852 $b)', 'Sublocation or collection (holdingbranch)', 1, 0, 'items.holdingbranch', 10, 'branches', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'c', 'Shelving location (similar to 852 $c, 876-8 $l)', 'Shelving location', 1, 0, 'items.location', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'd', 'Date acquired (similar to 541, 876-8 $d)', 'Date acquired', 0, 0, 'items.dateaccessioned', 10, 'usmarc_field_952v.pl', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'e', 'Source of acquisition (similar to 541 $a, 876-8 $e)', 'Source of acquisition', 1, 0, 'items.booksellerid', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'f', 'Coded location qualifier (similar to 852 $f)', 'Coded location qualifier', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'g', 'Non-coded location qualifier (similar to 852 $g)', 'Non-coded location qualifier', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'h', 'Classification part (similar to 852 $h)', 'Classification part', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'i', 'Item part (similar to 852 $i)', 'Item part', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'j', 'Shelving control number (similar to 852 $j)', 'Shelving control number', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'k', 'Call number prefix (similar to 852 $k)', 'Call number prefix', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'l', 'Shelving form of title (similar to 852 $l)', 'Shelving form of title', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'm', 'Call number suffix (similar to 852 $m)', 'Call number suffix', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'n', 'Country code (similar to 852 $n)', 'Country code', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'o', 'Call number (similar to 852 $k $h $i $m combined)', 'Call number', 0, 0, 'items.itemcallnumber', 10, '', '', NULL, 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'p', 'Piece designation (barcode) (similar to 852, 876-8 $p)', 'Piece designation (barcode)', 0, 1, 'items.barcode', 10, '', '', 'barcode.pl', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'q', 'Piece physical condition (similar to 562 $a, 852 $q)', 'Piece physical condition', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'r', 'Invalid or canceled piece designation (canceled barcode) (similar to 876-8 $r)', 'Invalid or canceled piece designation (canceled barcode)', 1, 0, '', 10, '', '', '', NULL, -1, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 's', 'Copyright article-fee code (similar to 018 $a, 852 $s)', 'Copyright article-fee code', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 't', 'Copy number (similar to 852, 876-8 $t)', 'Copy number', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'u', 'Cost, normal purchase price (similar to 541 $h, 876-8 $c)', 'Cost, normal purchase price', 0, 0, 'items.price', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'v', 'Cost, replacement price (similar to 365 $b, 876-8 $c)', 'Cost, replacement price', 0, 0, 'items.replacementprice', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'w', 'Price effective from (similar to 365 $f)', 'Price effective from', 0, 0, 'items.replacementpricedate', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'x', 'Nonpublic note (similar to 852, 876-8 $x)', 'Nonpublic note', 1, 0, '', 10, '', '', '', NULL, 6, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'y', 'Use restrictions (not for loan) (similar to 506 $a, 876-8 $h)', 'Use restrictions (not for loan)', 0, 0, 'items.notforloan', 10, '', '', '', 0, 0, '', '', '');
-- INSERT INTO `marc_subfield_structure` VALUES ('95k', 'z', 'Public note (similar to 852, 876-8 $z)', 'Public note', 0, 0, 'items.itemnotes', 10, '', '', '', 1, 0, '', '', '');



-- Current items Field/Subfields 


INSERT INTO `marc_tag_structure` VALUES ('952', 'LOCATION AND ITEM INFORMATION (KOHA)', 'LOCATION AND ITEM INFORMATION (KOHA)', 1, 0, '', '');

INSERT INTO `marc_subfield_structure` VALUES ('952', '0', 'Item status (withdrawn)', 'Item status (withdrawn)', 0, 0, 'items.withdrawn', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '1', 'Item status (lost)', 'Item status (lost)', 0, 0, 'items.itemlost', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '2', 'Source of classification or shelving scheme', 'Source of classification or shelving scheme', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '3', 'Materials specified', 'Materials specified', 0, 0, '', 10, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '4', 'Use restrictions', 'Use restrictions', 0, 0, 'items.restricted', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '6', 'Linkage', 'Linkage', 0, 0, '', 10, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '8', 'Sequence number', 'Sequence number', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', '9', 'Cost, normal purchase price', 'Cost, normal purchase price', 0, 0, 'items.price', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'a', 'Canceled barcode', 'Canceled barcode', 1, 0, '', 10, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'b', 'Location (homebranch)', 'Location (homebranch)', 0, 0, 'items.homebranch', 10, 'branches', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'c', 'Shelving location', 'Shelving location', 1, 0, 'items.location', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'd', 'Sublocation or collection (holdingbranch)', 'Sublocation or collection (holdingbranch)', 0, 0, 'items.holdingbranch', 10, 'branches', '', '', 0, 0, '', '''952b''', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'e', 'Source of acquisition', 'Source of acquisition', 1, 0, 'items.booksellerid', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'f', 'Coded location qualifier', 'Coded location qualifier', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'g', 'Non-coded location qualifier', 'Non-coded location qualifier', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'h', 'Classification part', 'Classification part', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'i', 'Item part', 'Item part', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'j', 'Shelving control number', 'Shelving control number', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'k', 'Call number (combined)', 'Call number', 0, 0, 'items.itemcallnumber', 10, '', '', NULL, 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'l', 'Shelving form of title', 'Shelving form of title', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'm', 'Call number suffix', 'Call number suffix', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'n', 'Country code', 'Country code', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'o', 'Call number prefix', 'Call number prefix', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'p', 'Barcode', 'Barcode', 0, 1, 'items.barcode', 10, '', '', 'barcode.pl', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'q', 'Piece physical condition', 'Piece physical condition', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'r', 'Cost, replacement price', 'Cost, replacement price', 0, 0, 'items.replacementprice', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 's', 'Copyright article-fee code', 'Copyright article-fee code', 1, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 't', 'Copy number', 'Copy number', 0, 0, '', 10, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'u', 'Koha itemnumber (autogenerated)', 'Koha itemnumber', 0, 0, 'items.itemnumber', -1, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'v', 'Date acquired', 'Date acquired', 0, 0, 'items.dateaccessioned', 10, 'usmarc_field_952v.pl', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'w', 'Price effective from', 'Price effective from', 0, 0, 'items.replacementpricedate', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 10, '', '', '', NULL, 6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'y', 'Use restrictions (not for loan)', 'Use restrictions (not for loan)', 0, 0, 'items.notforloan', 10, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('952', 'z', 'Public note', 'Public note', 0, 0, 'items.itemnotes', 10, '', '', '', 1, 0, '', '', '');


-- *******************************************************



-- *******************************************************
-- MARC 21 FIELDS/SUBFIELDS AND COMMMONLY USED EXTENSIONS 
-- *******************************************************


-- A Few local use codes need specifying.  Several seealso, plugin, and 
-- authority framework columns need improving.  $9 for authority record linking 
-- needs to be added where not already provided by RLIN specifications. 
-- Needs checking for errors but probably tolerable for use on a production. 
-- A server can be upgraded easily from later versions of this file.
--                                                                          
-- In the absense of more column support for qualifying the relative 
-- importance of subfields to the record editor, some modest modification of 
-- the default framework is needed setting the not-useful non-Koha holdings 
-- subfields to not managed in Koha.

-- MARC fields including letters as part of the field identifier are from RLIN
-- and should be expected to remain along with RLIN $% subfields.  RLIN has 
-- been using letters in fields because there are not enough local use number 
-- fields which have not already been specified for very large union catalogue 
-- networks such as RLIN itself.


-- Fields ending in c, o, or r are temporary placeholders for information from
-- a numeric value until a non-conflicting way to treat the content under the
-- proper original numeric field is adopted.  090 for LC call numbers is much 
-- too common and important so 999 is also provided as a temporary place 
-- holder until all Koha code for finding control fields has been changed from 
-- a numeric test of < 10 to a regular expression match of m/^00/ to prevent 
-- mistaken matching of fields with letters such as 09o if they were control 
-- fields.


INSERT INTO `marc_tag_structure` VALUES ('000', 'LEADER', 'LEADER', 0, 1, '', '');
INSERT INTO `marc_tag_structure` VALUES ('001', 'CONTROL NUMBER', 'CONTROL NUMBER', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('003', 'CONTROL NUMBER IDENTIFIER', 'CONTROL NUMBER IDENTIFIER', 0, 1, '', '');
INSERT INTO `marc_tag_structure` VALUES ('005', 'DATE AND TIME OF LATEST TRANSACTION', 'DATE AND TIME OF LATEST TRANSACTION', 0, 1, '', '');
INSERT INTO `marc_tag_structure` VALUES ('006', 'FIXED-LENGTH DATA ELEMENTS--ADDITIONAL MATERIAL CHARACTERISTICS--GENERAL INFORMATION', 'FIXED-LENGTH DATA ELEMENTS--ADDITIONAL MATERIAL CHARACTERISTICS--GENERAL INFORMATION', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('007', 'PHYSICAL DESCRIPTION FIXED FIELD--GENERAL INFORMATION', 'PHYSICAL DESCRIPTION FIXED FIELD--GENERAL INFORMATION', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('008', 'FIXED-LENGTH DATA ELEMENTS--GENERAL INFORMATION', 'FIXED-LENGTH DATA ELEMENTS--GENERAL INFORMATION', 0, 1, '', '');
INSERT INTO `marc_tag_structure` VALUES ('009', 'PHYSICAL DESCRIPTION FIXED-FIELD FOR ARCHIVAL COLLECTION (VM) [OBSOLETE]', 'PHYSICAL DESCRIPTION FIXED-FIELD FOR ARCHIVAL COLLECTION (VM) [OBSOLETE]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('010', 'LIBRARY OF CONGRESS CONTROL NUMBER', 'LIBRARY OF CONGRESS CONTROL NUMBER', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('011', 'LINKING LIBRARY OF CONGRESS CONTROL NUMBER [OBSOLETE]', 'LINKING LIBRARY OF CONGRESS CONTROL NUMBER [OBSOLETE]', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('013', 'PATENT CONTROL INFORMATION', 'PATENT CONTROL INFORMATION', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('015', 'NATIONAL BIBLIOGRAPHY NUMBER', 'NATIONAL BIBLIOGRAPHY NUMBER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('016', 'NATIONAL BIBLIOGRAPHIC AGENCY CONTROL NUMBER', 'NATIONAL BIBLIOGRAPHIC AGENCY CONTROL NUMBER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('017', 'COPYRIGHT OR LEGAL DEPOSIT NUMBER', 'COPYRIGHT OR LEGAL DEPOSIT NUMBER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('018', 'COPYRIGHT ARTICLE-FEE CODE', 'COPYRIGHT ARTICLE-FEE CODE', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('01e', 'CODED FIELD ERROR (RLIN)', 'CODED FIELD ERROR (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('020', 'INTERNATIONAL STANDARD BOOK NUMBER', 'INTERNATIONAL STANDARD BOOK NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('022', 'INTERNATIONAL STANDARD SERIAL NUMBER', 'INTERNATIONAL STANDARD SERIAL NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('023', 'STANDARD FILM NUMBER (VM) [DELETED]', 'STANDARD FILM NUMBER (VM) [DELETED]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('024', 'OTHER STANDARD IDENTIFIER', 'OTHER STANDARD IDENTIFIER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('025', 'OVERSEAS ACQUISITION NUMBER', 'OVERSEAS ACQUISITION NUMBER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('026', 'FINGERPRINT IDENTIFIER', 'FINGERPRINT IDENTIFIER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('027', 'STANDARD TECHNICAL REPORT NUMBER', 'STANDARD TECHNICAL REPORT NUMBER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('028', 'PUBLISHER NUMBER', 'PUBLISHER NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('029', 'OTHER SYSTEM CONTROL NUMBER (OCLC)', ' (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('030', 'CODEN DESIGNATION', 'CODEN DESIGNATION', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('031', 'MUSICAL INCIPITS INFORMATION', 'MUSICAL INCIPITS INFORMATION', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('032', 'POSTAL REGISTRATION NUMBER', 'POSTAL REGISTRATION NUMBER', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('033', 'DATE/TIME AND PLACE OF AN EVENT', 'DATE/TIME AND PLACE OF AN EVENT', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('034', 'CODED CARTOGRAPHIC MATHEMATICAL DATA', 'CODED CARTOGRAPHIC MATHEMATICAL DATA', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('035', 'SYSTEM CONTROL NUMBER', 'SYSTEM CONTROL NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('036', 'ORIGINAL STUDY NUMBER FOR COMPUTER DATA FILES', 'ORIGINAL STUDY NUMBER FOR COMPUTER DATA FILES', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('037', 'SOURCE OF ACQUISITION', 'SOURCE OF ACQUISITION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('038', 'RECORD CONTENT LICENSOR', 'RECORD CONTENT LICENSOR', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('039', 'LEVEL OF BIBLIOGRAPHIC CONTROL AND CODING DETAIL [OBSOLETE]', 'LEVEL OF BIBLIOGRAPHIC CONTROL AND CODING DETAIL [OBSOLETE]', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('040', 'CATALOGING SOURCE', 'CATALOGING SOURCE', 0, 1, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('041', 'LANGUAGE CODE', 'LANGUAGE CODE', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('042', 'AUTHENTICATION CODE', 'AUTHENTICATION CODE', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('043', 'GEOGRAPHIC AREA CODE', 'GEOGRAPHIC AREA CODE', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('044', 'COUNTRY OF PUBLISHING/PRODUCING ENTITY CODE', 'COUNTRY OF PUBLISHING/PRODUCING ENTITY CODE', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('045', 'TIME PERIOD OF CONTENT', 'TIME PERIOD OF CONTENT', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('046', 'SPECIAL CODED DATES', 'SPECIAL CODED DATES', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('047', 'FORM OF MUSICAL COMPOSITION CODE', 'FORM OF MUSICAL COMPOSITION CODE', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('048', 'NUMBER OF MUSICAL INSTRUMENTS OR VOICES CODE', 'NUMBER OF MUSICAL INSTRUMENTS OR VOICES CODE', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('049', 'LOCAL HOLDINGS (OCLC)', 'LOCAL HOLDINGS (OCLC)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('050', 'LIBRARY OF CONGRESS CALL NUMBER', 'LIBRARY OF CONGRESS CALL NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('051', 'LIBRARY OF CONGRESS COPY, ISSUE, OFFPRINT STATEMENT', 'LIBRARY OF CONGRESS COPY, ISSUE, OFFPRINT STATEMENT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('052', 'GEOGRAPHIC CLASSIFICATION', 'GEOGRAPHIC CLASSIFICATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('055', 'CLASSIFICATION NUMBERS ASSIGNED IN CANADA', 'CLASSIFICATION NUMBERS ASSIGNED IN CANADA', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('060', 'NATIONAL LIBRARY OF MEDICINE CALL NUMBER', 'NATIONAL LIBRARY OF MEDICINE CALL NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('061', 'NATIONAL LIBRARY OF MEDICINE COPY STATEMENT', 'NATIONAL LIBRARY OF MEDICINE COPY STATEMENT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('066', 'CHARACTER SETS PRESENT', 'CHARACTER SETS PRESENT', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('070', 'NATIONAL AGRICULTURAL LIBRARY CALL NUMBER', 'NATIONAL AGRICULTURAL LIBRARY CALL NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('071', 'NATIONAL AGRICULTURAL LIBRARY COPY STATEMENT', 'NATIONAL AGRICULTURAL LIBRARY COPY STATEMENT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('072', 'SUBJECT CATEGORY CODE', 'SUBJECT CATEGORY CODE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('074', 'GPO ITEM NUMBER', 'GPO ITEM NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('080', 'UNIVERSAL DECIMAL CLASSIFICATION NUMBER', 'UNIVERSAL DECIMAL CLASSIFICATION NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('082', 'DEWEY DECIMAL CLASSIFICATION NUMBER', 'DEWEY DECIMAL CLASSIFICATION NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('084', 'OTHER CLASSIFICATION NUMBER', 'OTHER CLASSIFICATION NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('086', 'GOVERNMENT DOCUMENT CLASSIFICATION NUMBER', 'GOVERNMENT DOCUMENT CLASSIFICATION NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('087', 'REPORT NUMBER [OBSOLETE, CAN/MARC]', 'REPORT NUMBER [OBSOLETE, CAN/MARC]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('088', 'REPORT NUMBER', 'REPORT NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('09o', 'LOCALLY ASSIGNED LC-TYPE CALL NUMBER (OCLC); LOCAL CALL NUMBER (RLIN)', 'LOCALLY ASSIGNED LC-TYPE CALL NUMBER (OCLC); LOCAL CALL NUMBER (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('091', 'MICROFILM SHELF LOCATION (AM) [OBSOLETE]', 'MICROFILM SHELF LOCATION (AM) [OBSOLETE]', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('092', 'LOCALLY ASSIGNED DEWEY CALL NUMBER (OCLC)', 'LOCALLY ASSIGNED DEWEY CALL NUMBER (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('096', 'LOCALLY ASSIGNED NLM-TYPE CALL NUMBER (OCLC)', 'LOCALLY ASSIGNED NLM-TYPE CALL NUMBER (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('098', 'OTHER CLASSIFICATION SCHEMES (OCLC)', 'OTHER CLASSIFICATION SCHEMES (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('099', 'LOCAL FREE-TEXT CALL NUMBER (OCLC)', 'LOCAL FREE-TEXT CALL NUMBER (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('100', 'MAIN ENTRY--PERSONAL NAME', 'MAIN ENTRY--PERSONAL NAME', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('110', 'MAIN ENTRY--CORPORATE NAME', 'MAIN ENTRY--CORPORATE NAME', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('111', 'MAIN ENTRY--MEETING NAME', 'MAIN ENTRY--MEETING NAME', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('130', 'MAIN ENTRY--UNIFORM TITLE', 'MAIN ENTRY--UNIFORM TITLE', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('210', 'ABBREVIATED TITLE', 'ABBREVIATED TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('211', 'ACRONYM OR SHORTENED TITLE [OBSOLETE]', 'ACRONYM OR SHORTENED TITLE [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('212', 'VARIANT ACCESS TITLE [OBSOLETE]', 'VARIANT ACCESS TITLE [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('214', 'AUGMENTED TITLE [OBSOLETE]', 'AUGMENTED TITLE [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('222', 'KEY TITLE', 'KEY TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('240', 'UNIFORM TITLE', 'UNIFORM TITLE', 0, 0, 'Unititle', '');
INSERT INTO `marc_tag_structure` VALUES ('241', 'ROMANIZED TITLE (BK AM CF MP MU VM) [OBSOLETE]', 'ROMANIZED TITLE (BK AM CF MP MU VM) [OBSOLETE]', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('242', 'TRANSLATION OF TITLE BY CATALOGING AGENCY', 'TRANSLATION OF TITLE BY CATALOGING AGENCY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('243', 'COLLECTIVE UNIFORM TITLE', 'COLLECTIVE UNIFORM TITLE', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('245', 'TITLE STATEMENT', 'TITLE STATEMENT', 0, 1, '', '');
INSERT INTO `marc_tag_structure` VALUES ('246', 'VARYING FORM OF TITLE', 'VARYING FORM OF TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('247', 'FORMER TITLE', 'FORMER TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('250', 'EDITION STATEMENT', 'EDITION STATEMENT', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('254', 'MUSICAL PRESENTATION STATEMENT', 'MUSICAL PRESENTATION STATEMENT', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('255', 'CARTOGRAPHIC MATHEMATICAL DATA', 'CARTOGRAPHIC MATHEMATICAL DATA', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('256', 'COMPUTER FILE CHARACTERISTICS', 'COMPUTER FILE CHARACTERISTICS', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('257', 'COUNTRY OF PRODUCING ENTITY FOR ARCHIVAL FILMS', 'COUNTRY OF PRODUCING ENTITY FOR ARCHIVAL FILMS', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('258', 'PHILATELIC ISSUE DATE', 'PHILATELIC ISSUE DATE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('260', 'PUBLICATION, DISTRIBUTION, ETC. (IMPRINT)', 'PUBLICATION, DISTRIBUTION, ETC. (IMPRINT)', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('261', 'IMPRINT STATEMENT FOR FILMS (Pre-AACR 1 Revised) [OBSOLETE, CAN/MARC], [LOCAL, USA]', 'IMPRINT STATEMENT FOR FILMS (Pre-AACR 1 Revised) [OBSOLETE, CAN/MARC], [LOCAL, USA]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('262', 'IMPRINT STATEMENT FOR SOUND RECORDINGS (Pre-AACR 2) [LOCAL, USA]', 'IMPRINT STATEMENT FOR SOUND RECORDINGS (Pre-AACR 2) [LOCAL, USA]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('263', 'PROJECTED PUBLICATION DATE', 'PROJECTED PUBLICATION DATE', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('265', 'SOURCE FOR ACQUISITION/SUBSCRIPTION ADDRESS [OBSOLETE]', 'SOURCE FOR ACQUISITION/SUBSCRIPTION ADDRESS [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('270', 'ADDRESS', 'ADDRESS', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('300', 'PHYSICAL DESCRIPTION', 'PHYSICAL DESCRIPTION', 1, 1, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('301', 'PHYSICAL DESCRIPTION FOR FILMS (PRE-AACR 2) (VM) [OBSOLETE, USMARC]', 'PHYSICAL DESCRIPTION FOR FILMS (PRE-AACR 2) (VM) [OBSOLETE, USMARC]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('302', 'PAGE OR ITEM COUNT (BK AM) [OBSOLETE]', 'PAGE OR ITEM COUNT (BK AM) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('303', 'UNIT COUNT (AM) [OBSOLETE, USMARC]', 'UNIT COUNT (AM) [OBSOLETE, USMARC]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('304', 'LINEAR FOOTAGE (AM) [OBSOLETE, USMARC]', 'LINEAR FOOTAGE (AM) [OBSOLETE, USMARC]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('305', 'PHYSICAL DESCRIPTION FOR SOUND RECORDINGS (Pre-AACR 2) (MU) [OBSOLETE]', 'PHYSICAL DESCRIPTION FOR SOUND RECORDINGS (Pre-AACR 2) (MU) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('306', 'PLAYING TIME', 'PLAYING TIME', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('307', 'HOURS, ETC.', 'HOURS, ETC.', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('308', 'PHYSICAL DESCRIPTION FOR FILMS (ARCHIVAL) (VM) [OBSOLETE]', 'PHYSICAL DESCRIPTION FOR FILMS (ARCHIVAL) (VM) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('310', 'CURRENT PUBLICATION FREQUENCY', 'CURRENT PUBLICATION FREQUENCY', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('315', 'FREQUENCY (CF MP) [OBSOLETE]', 'FREQUENCY (CF MP) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('321', 'FORMER PUBLICATION FREQUENCY', 'FORMER PUBLICATION FREQUENCY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('340', 'PHYSICAL MEDIUM', 'PHYSICAL MEDIUM', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('342', 'GEOSPATIAL REFERENCE DATA', 'GEOSPATIAL REFERENCE DATA', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('343', 'PLANAR COORDINATE DATA', 'PLANAR COORDINATE DATA', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('350', 'PRICE (NR) (BK AM CF MU VM SE) [OBSOLETE]', 'PRICE (NR) (BK AM CF MU VM SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('351', 'ORGANIZATION AND ARRANGEMENT OF MATERIALS', 'ORGANIZATION AND ARRANGEMENT OF MATERIALS', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('352', 'DIGITAL GRAPHIC REPRESENTATION', 'DIGITAL GRAPHIC REPRESENTATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('355', 'SECURITY CLASSIFICATION CONTROL', 'SECURITY CLASSIFICATION CONTROL', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('357', 'ORIGINATOR DISSEMINATION CONTROL', 'ORIGINATOR DISSEMINATION CONTROL', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('359', 'RENTAL PRICE (VM) [OBSOLETE]', 'RENTAL PRICE (VM) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('362', 'DATES OF PUBLICATION AND/OR SEQUENTIAL DESIGNATION', 'DATES OF PUBLICATION AND/OR SEQUENTIAL DESIGNATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('365', 'TRADE PRICE', 'TRADE PRICE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('366', 'TRADE AVAILABILITY INFORMATION', 'TRADE AVAILABILITY INFORMATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('400', 'SERIES STATEMENT/ADDED ENTRY--PERSONAL NAME [OBSOLETE, CAN/MARC], [LOCAL, USA]', 'SERIES STATEMENT/ADDED ENTRY--PERSONAL NAME [OBSOLETE, CAN/MARC], [LOCAL, USA]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('410', 'SERIES STATEMENT/ADDED ENTRY--CORPORATE NAME [OBSOLETE, CAN/MARC], [LOCAL, USA]', 'SERIES STATEMENT/ADDED ENTRY--CORPORATE NAME [OBSOLETE, CAN/MARC], [LOCAL, USA]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('411', 'SERIES STATEMENT/ADDED ENTRY--MEETING NAME [OBSOLETE, CAN/MARC], [LOCAL, USA]', 'SERIES STATEMENT/ADDED ENTRY--MEETING NAME [OBSOLETE, CAN/MARC], [LOCAL, USA]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('440', 'SERIES STATEMENT/ADDED ENTRY--TITLE', 'SERIES STATEMENT/ADDED ENTRY--TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('490', 'SERIES STATEMENT', 'SERIES STATEMENT', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('500', 'GENERAL NOTE', 'GENERAL NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('501', 'WITH NOTE', 'WITH NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('502', 'DISSERTATION NOTE', 'DISSERTATION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('503', 'BIBLIOGRAPHIC HISTORY NOTE (BK CF MU) [OBSOLETE]', 'BIBLIOGRAPHIC HISTORY NOTE (BK CF MU) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('504', 'BIBLIOGRAPHY, ETC. NOTE', 'BIBLIOGRAPHY, ETC. NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('505', 'FORMATTED CONTENTS NOTE', 'FORMATTED CONTENTS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('506', 'RESTRICTIONS ON ACCESS NOTE', 'RESTRICTIONS ON ACCESS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('507', 'SCALE NOTE FOR GRAPHIC MATERIAL', 'SCALE NOTE FOR GRAPHIC MATERIAL', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('508', 'CREATION/PRODUCTION CREDITS NOTE', 'CREATION/PRODUCTION CREDITS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('509', 'INFORMAL NOTES (RLIN)', 'INFORMAL NOTES (RLIN)', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('510', 'CITATION/REFERENCES NOTE', 'CITATION/REFERENCES NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('511', 'PARTICIPANT OR PERFORMER NOTE', 'PARTICIPANT OR PERFORMER NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('512', 'EARLIER OR LATER VOLUMES SEPARATELY CATALOGED NOTE (SE) [OBSOLETE]', 'EARLIER OR LATER VOLUMES SEPARATELY CATALOGED NOTE (SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('513', 'TYPE OF REPORT AND PERIOD COVERED NOTE', 'TYPE OF REPORT AND PERIOD COVERED NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('514', 'DATA QUALITY NOTE', 'DATA QUALITY NOTE', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('515', 'NUMBERING PECULIARITIES NOTE', 'NUMBERING PECULIARITIES NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('516', 'TYPE OF COMPUTER FILE OR DATA NOTE', 'TYPE OF COMPUTER FILE OR DATA NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('517', 'CATEGORIES OF FILMS NOTE (ARCHIVAL) (VM) [OBSOLETE]', 'CATEGORIES OF FILMS NOTE (ARCHIVAL) (VM) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('518', 'DATE/TIME AND PLACE OF AN EVENT NOTE', 'DATE/TIME AND PLACE OF AN EVENT NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('520', 'SUMMARY, ETC.', 'SUMMARY, ETC.', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('521', 'TARGET AUDIENCE NOTE', 'TARGET AUDIENCE NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('522', 'GEOGRAPHIC COVERAGE NOTE', 'GEOGRAPHIC COVERAGE NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('523', 'TIME PERIOD OF CONTENT NOTE (CF) [OBSOLETE]', 'TIME PERIOD OF CONTENT NOTE (CF) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('524', 'PREFERRED CITATION OF DESCRIBED MATERIALS NOTE', 'PREFERRED CITATION OF DESCRIBED MATERIALS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('525', 'SUPPLEMENT NOTE', 'SUPPLEMENT NOTE', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('526', 'STUDY PROGRAM INFORMATION NOTE', 'STUDY PROGRAM INFORMATION NOTE', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('527', 'CENSORSHIP NOTE (VM) [OBSOLETE]', 'CENSORSHIP NOTE (VM) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('530', 'ADDITIONAL PHYSICAL FORM AVAILABLE NOTE', 'ADDITIONAL PHYSICAL FORM AVAILABLE NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('533', 'REPRODUCTION NOTE', 'REPRODUCTION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('534', 'ORIGINAL VERSION NOTE', 'ORIGINAL VERSION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('535', 'LOCATION OF ORIGINALS/DUPLICATES NOTE', 'LOCATION OF ORIGINALS/DUPLICATES NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('536', 'FUNDING INFORMATION NOTE', 'FUNDING INFORMATION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('537', 'SOURCE OF DATA NOTE (CF) [OBSOLETE]', 'SOURCE OF DATA NOTE (CF) [OBSOLETE]', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('538', 'SYSTEM DETAILS NOTE', 'SYSTEM DETAILS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('540', 'TERMS GOVERNING USE AND REPRODUCTION NOTE', 'TERMS GOVERNING USE AND REPRODUCTION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('541', 'IMMEDIATE SOURCE OF ACQUISITION NOTE', 'IMMEDIATE SOURCE OF ACQUISITION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('543', 'SOLICITATION INFORMATION NOTE (AM) [OBSOLETE]', 'SOLICITATION INFORMATION NOTE (AM) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('544', 'LOCATION OF OTHER ARCHIVAL MATERIALS NOTE', 'LOCATION OF OTHER ARCHIVAL MATERIALS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('546', 'LANGUAGE NOTE', 'LANGUAGE NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('547', 'FORMER TITLE COMPLEXITY NOTE', 'FORMER TITLE COMPLEXITY NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('550', 'ISSUING BODY NOTE', 'ISSUING BODY NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('552', 'ENTITY AND ATTRIBUTE INFORMATION NOTE', 'ENTITY AND ATTRIBUTE INFORMATION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('555', 'CUMULATIVE INDEX/FINDING AIDS NOTE', 'CUMULATIVE INDEX/FINDING AIDS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('556', 'INFORMATION ABOUT DOCUMENTATION NOTE', 'INFORMATION ABOUT DOCUMENTATION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('561', 'OWNERSHIP AND CUSTODIAL HISTORY', 'OWNERSHIP AND CUSTODIAL HISTORY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('562', 'COPY AND VERSION IDENTIFICATION NOTE', 'COPY AND VERSION IDENTIFICATION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('563', 'BINDING INFORMATION', 'BINDING INFORMATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('565', 'CASE FILE CHARACTERISTICS NOTE', 'CASE FILE CHARACTERISTICS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('567', 'METHODOLOGY NOTE', 'METHODOLOGY NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('570', 'EDITOR NOTE (SE) [OBSOLETE]', 'EDITOR NOTE (SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('580', 'LINKING ENTRY COMPLEXITY NOTE', 'LINKING ENTRY COMPLEXITY NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('581', 'PUBLICATIONS ABOUT DESCRIBED MATERIALS NOTE', 'PUBLICATIONS ABOUT DESCRIBED MATERIALS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('582', 'RELATED COMPUTER FILES NOTE (CF) [OBSOLETE]', 'RELATED COMPUTER FILES NOTE (CF) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('583', 'ACTION NOTE', 'ACTION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('584', 'ACCUMULATION AND FREQUENCY OF USE NOTE', 'ACCUMULATION AND FREQUENCY OF USE NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('585', 'EXHIBITIONS NOTE', 'EXHIBITIONS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('586', 'AWARDS NOTE', 'AWARDS NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('590', 'LOCAL NOTE (RLIN)', 'LOCAL NOTE (RLIN)', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('600', 'SUBJECT ADDED ENTRY--PERSONAL NAME', 'SUBJECT ADDED ENTRY--PERSONAL NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('610', 'SUBJECT ADDED ENTRY--CORPORATE NAME', 'SUBJECT ADDED ENTRY--CORPORATE NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('611', 'SUBJECT ADDED ENTRY--MEETING NAME', 'SUBJECT ADDED ENTRY--MEETING NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('630', 'SUBJECT ADDED ENTRY--UNIFORM TITLE', 'SUBJECT ADDED ENTRY--UNIFORM TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('648', 'SUBJECT ADDED ENTRY--CHRONOLOGICAL TERM', 'SUBJECT ADDED ENTRY--CHRONOLOGICAL TERM', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('650', 'SUBJECT ADDED ENTRY--TOPICAL TERM', 'SUBJECT ADDED ENTRY--TOPICAL TERM', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('651', 'SUBJECT ADDED ENTRY--GEOGRAPHIC NAME', 'SUBJECT ADDED ENTRY--GEOGRAPHIC NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('652', 'SUBJECT ADDED ENTRY--REVERSE GEOGRAPHIC (BK MP SE) [OBSOLETE]', 'SUBJECT ADDED ENTRY--REVERSE GEOGRAPHIC (BK MP SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('653', 'INDEX TERM--UNCONTROLLED', 'INDEX TERM--UNCONTROLLED', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('654', 'SUBJECT ADDED ENTRY--FACETED TOPICAL TERM', 'SUBJECT ADDED ENTRY--FACETED TOPICAL TERM', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('655', 'INDEX TERM--GENRE/FORM', 'INDEX TERM--GENRE/FORM', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('656', 'INDEX TERM--OCCUPATION', 'INDEX TERM--OCCUPATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('657', 'INDEX TERM--FUNCTION', 'INDEX TERM--FUNCTION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('658', 'INDEX TERM--CURRICULUM OBJECTIVE', 'INDEX TERM--CURRICULUM OBJECTIVE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('662', 'SUBJECT ADDED ENTRY--HIERARCHICAL PLACE NAME', 'SUBJECT ADDED ENTRY--HIERARCHICAL PLACE NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('690', 'LOCAL SUBJECT ADDED ENTRY--TOPICAL TERM (OCLC, RLIN)', 'LOCAL SUBJECT ADDED ENTRY--TOPICAL TERM (OCLC, RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('691', 'LOCAL SUBJECT ADDED ENTRY--GEOGRAPHIC NAME (RLIN)', 'LOCAL SUBJECT ADDED ENTRY--GEOGRAPHIC NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('696', 'LOCAL SUBJECT ADDED ENTRY--PERSONAL NAME (RLIN)', 'LOCAL SUBJECT ADDED ENTRY--PERSONAL NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('697', 'LOCAL SUBJECT ADDED ENTRY--CORPORATE NAME (RLIN)', 'LOCAL SUBJECT ADDED ENTRY--CORPORATE NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('698', 'LOCAL SUBJECT ADDED ENTRY--MEETING NAME (RLIN)', 'LOCAL SUBJECT ADDED ENTRY--MEETING NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('699', 'LOCAL SUBJECT ADDED ENTRY--UNIFORM TITLE (RLIN)', 'LOCAL SUBJECT ADDED ENTRY--UNIFORM TITLE (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('700', 'ADDED ENTRY--PERSONAL NAME', 'ADDED ENTRY--PERSONAL NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('705', 'ADDED ENTRY--PERSONAL NAME (PERFORMER) (MU) [OBSOLETE]', 'ADDED ENTRY--PERSONAL NAME (PERFORMER) (MU) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('710', 'ADDED ENTRY--CORPORATE NAME', 'ADDED ENTRY--CORPORATE NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('711', 'ADDED ENTRY--MEETING NAME', 'ADDED ENTRY--MEETING NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('715', 'ADDED ENTRY--CORPORATE NAME (PERFORMER) (MU) [OBSOLETE]', 'ADDED ENTRY--CORPORATE NAME (PERFORMER) (MU) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('720', 'ADDED ENTRY--UNCONTROLLED NAME', 'ADDED ENTRY--UNCONTROLLED NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('730', 'ADDED ENTRY--UNIFORM TITLE', 'ADDED ENTRY--UNIFORM TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('740', 'ADDED ENTRY--UNCONTROLLED RELATED/ANALYTICAL TITLE', 'ADDED ENTRY--UNCONTROLLED RELATED/ANALYTICAL TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('752', 'ADDED ENTRY--HIERARCHICAL PLACE NAME', 'ADDED ENTRY--HIERARCHICAL PLACE NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('753', 'SYSTEM DETAILS ACCESS TO COMPUTER FILES', 'SYSTEM DETAILS ACCESS TO COMPUTER FILES', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('754', 'ADDED ENTRY--TAXONOMIC IDENTIFICATION', 'ADDED ENTRY--TAXONOMIC IDENTIFICATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('755', 'ADDED ENTRY--PHYSICAL CHARACTERISTICS [OBSOLETE]', 'ADDED ENTRY--PHYSICAL CHARACTERISTICS [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('760', 'MAIN SERIES ENTRY', 'MAIN SERIES ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('762', 'SUBSERIES ENTRY', 'SUBSERIES ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('765', 'ORIGINAL LANGUAGE ENTRY', 'ORIGINAL LANGUAGE ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('767', 'TRANSLATION ENTRY', 'TRANSLATION ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('770', 'SUPPLEMENT/SPECIAL ISSUE ENTRY', 'SUPPLEMENT/SPECIAL ISSUE ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('772', 'SUPPLEMENT PARENT ENTRY', 'SUPPLEMENT PARENT ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('773', 'HOST ITEM ENTRY', 'HOST ITEM ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('774', 'CONSTITUENT UNIT ENTRY', 'CONSTITUENT UNIT ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('775', 'OTHER EDITION ENTRY', 'OTHER EDITION ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('776', 'ADDITIONAL PHYSICAL FORM ENTRY', 'ADDITIONAL PHYSICAL FORM ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('777', 'ISSUED WITH ENTRY', 'ISSUED WITH ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('780', 'PRECEDING ENTRY', 'PRECEDING ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('785', 'SUCCEEDING ENTRY', 'SUCCEEDING ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('786', 'DATA SOURCE ENTRY', 'DATA SOURCE ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('787', 'NONSPECIFIC RELATIONSHIP ENTRY', 'NONSPECIFIC RELATIONSHIP ENTRY', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('789', 'COMPONENT ITEM ENTRY (RLIN)', 'COMPONENT ITEM ENTRY (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('796', 'LOCAL ADDED ENTRY--PERSONAL NAME (RLIN)', 'LOCAL ADDED ENTRY--PERSONAL NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('797', 'LOCAL ADDED ENTRY--CORPORATE NAME (RLIN)', 'LOCAL ADDED ENTRY--CORPORATE NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('798', 'LOCAL ADDED ENTRY--MEETING NAME (RLIN)', 'LOCAL ADDED ENTRY--MEETING NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('799', 'LOCAL ADDED ENTRY--UNIFORM TITLE (RLIN)', 'LOCAL ADDED ENTRY--UNIFORM TITLE (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('800', 'SERIES ADDED ENTRY--PERSONAL NAME', 'SERIES ADDED ENTRY--PERSONAL NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('810', 'SERIES ADDED ENTRY--CORPORATE NAME', 'SERIES ADDED ENTRY--CORPORATE NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('811', 'SERIES ADDED ENTRY--MEETING NAME', 'SERIES ADDED ENTRY--MEETING NAME', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('830', 'SERIES ADDED ENTRY--UNIFORM TITLE', 'SERIES ADDED ENTRY--UNIFORM TITLE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('840', 'SERIES ADDED ENTRY--TITLE [OBSOLETE]', 'SERIES ADDED ENTRY--TITLE [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('841', 'HOLDINGS CODED DATA VALUES', 'HOLDINGS CODED DATA VALUES', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('842', 'TEXTUAL PHYSICAL FORM DESIGNATOR', 'TEXTUAL PHYSICAL FORM DESIGNATOR', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('843', 'REPRODUCTION NOTE', 'REPRODUCTION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('844', 'NAME OF UNIT', 'NAME OF UNIT', 0, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('845', 'TERMS GOVERNING USE AND REPRODUCTION NOTE', 'TERMS GOVERNING USE AND REPRODUCTION NOTE', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('850', 'HOLDING INSTITUTION', 'HOLDING INSTITUTION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('851', 'LOCATION [OBSOLETE]', 'LOCATION [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('852', 'LOCATION/CALL NUMBER', 'LOCATION/CALL NUMBER', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('853', 'CAPTIONS AND PATTERN--BASIC BIBLIOGRAPHIC UNIT', 'CAPTIONS AND PATTERN--BASIC BIBLIOGRAPHIC UNIT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('854', 'CAPTIONS AND PATTERN--SUPPLEMENTARY MATERIAL', 'CAPTIONS AND PATTERN--SUPPLEMENTARY MATERIAL', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('855', 'CAPTIONS AND PATTERN--INDEXES', 'CAPTIONS AND PATTERN--INDEXES', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('856', 'ELECTRONIC LOCATION AND ACCESS', 'ELECTRONIC LOCATION AND ACCESS', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('859', 'LOCAL CONTROL INFORMATION (RLIN)', 'LOCAL CONTROL INFORMATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('863', 'ENUMERATION AND CHRONOLOGY--BASIC BIBLIOGRAPHIC UNIT', 'ENUMERATION AND CHRONOLOGY--BASIC BIBLIOGRAPHIC UNIT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('864', 'ENUMERATION AND CHRONOLOGY--SUPPLEMENTARY MATERIAL', 'ENUMERATION AND CHRONOLOGY--SUPPLEMENTARY MATERIAL', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('865', 'ENUMERATION AND CHRONOLOGY--INDEXES', 'ENUMERATION AND CHRONOLOGY--INDEXES', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('866', 'TEXTUAL HOLDINGS--BASIC BIBLIOGRAPHIC UNIT', 'TEXTUAL HOLDINGS--BASIC BIBLIOGRAPHIC UNIT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('867', 'TEXTUAL HOLDINGS--SUPPLEMENTARY MATERIAL', 'TEXTUAL HOLDINGS--SUPPLEMENTARY MATERIAL', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('868', 'TEXTUAL HOLDINGS--INDEXES', 'TEXTUAL HOLDINGS--INDEXES', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('870', 'VARIANT PERSONAL NAME (SE) [OBSOLETE]', 'VARIANT PERSONAL NAME (SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('871', 'VARIANT CORPORATE NAME (SE)[OBSOLETE]', 'VARIANT CORPORATE NAME (SE)[OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('872', 'VARIANT CONFERENCE OR MEETING NAME (SE) [OBSOLETE]', 'VARIANT CONFERENCE OR MEETING NAME (SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('873', 'VARIANT UNIFORM TITLE HEADING (SE) [OBSOLETE]', 'VARIANT UNIFORM TITLE HEADING (SE) [OBSOLETE]', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('876', 'ITEM INFORMATION--BASIC BIBLIOGRAPHIC UNIT', 'ITEM INFORMATION--BASIC BIBLIOGRAPHIC UNIT', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('877', 'ITEM INFORMATION--SUPPLEMENTARY MATERIAL', 'ITEM INFORMATION--SUPPLEMENTARY MATERIAL', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('878', 'ITEM INFORMATION--INDEXES', 'ITEM INFORMATION--INDEXES', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('880', 'ALTERNATE GRAPHIC REPRESENTATION', 'ALTERNATE GRAPHIC REPRESENTATION', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('886', 'FOREIGN MARC INFORMATION FIELD', 'FOREIGN MARC INFORMATION FIELD', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('887', 'NON-MARC INFORMATION FIELD', 'NON-MARC INFORMATION FIELD', 1, 0, NULL, '');
INSERT INTO `marc_tag_structure` VALUES ('896', 'LOCAL SERIES ADDED ENTRY--PERSONAL NAME (RLIN)', 'LOCAL SERIES ADDED ENTRY--PERSONAL NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('897', 'LOCAL SERIES ADDED ENTRY--CORPORATE NAME (RLIN)', 'LOCAL SERIES ADDED ENTRY--CORPORATE NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('898', 'LOCAL SERIES ADDED ENTRY--MEETING NAME (RLIN)', 'LOCAL SERIES ADDED ENTRY--MEETING NAME (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('899', 'LOCAL SERIES ADDED ENTRY--UNIFORM TITLE (RLIN)', 'LOCAL SERIES ADDED ENTRY--UNIFORM TITLE (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('89e', 'ERRONEOUS FIELD, ERR (RLIN)', 'ERRONEOUS FIELD, ERR (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('900', 'EQUIVALENCE OR CROSS-REFERENCE-PERSONAL NAME [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-PERSONAL NAME [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('901', 'LOCAL DATA ELEMENT A, LDA (RLIN)', 'LOCAL DATA ELEMENT A, LDA (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('902', 'LOCAL DATA ELEMENT B, LDB (RLIN)', 'LOCAL DATA ELEMENT B, LDB (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('903', 'LOCAL DATA ELEMENT C, LDC (RLIN)', 'LOCAL DATA ELEMENT C, LDC (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('904', 'LOCAL DATA ELEMENT D, LDD (RLIN)', 'LOCAL DATA ELEMENT D, LDD (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('905', 'LOCAL DATA ELEMENT E, LDE (RLIN)', 'LOCAL DATA ELEMENT E, LDE (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('906', 'LOCAL DATA ELEMENT F, LDF (RLIN)', 'LOCAL DATA ELEMENT F, LDF (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('907', 'LOCAL DATA ELEMENT G, LDG (RLIN)', 'LOCAL DATA ELEMENT G, LDG (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('908', 'PUT COMMAND PARAMETER (RLIN)', 'PUT COMMAND PARAMETER (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('910', 'EQUIVALENCE OR CROSS-REFERENCE-CORPORATE NAME [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-CORPORATE NAME [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('91o', 'USER-OPTION DATA (COLC)', 'USER-OPTION DATA (OCLC)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('91r', 'RLG STANDARDS NOTE (RLIN)', 'RLG STANDARDS NOTE (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('911', 'EQUIVALENCE OR CROSS-REFERENCE-CONFERENCE OR MEETING NAME [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-CONFERENCE OR MEETING NAME [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('930', 'EQUIVALENCE OR CROSS-REFERENCE-UNIFORM TITLE HEADING [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-UNIFORM TITLE HEADING [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('93r', 'SUMMARY HOLDINGS STATEMENT (RLIN)', 'SUMMARY HOLDINGS STATEMENT (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('936', 'OCLC/CONSER MISCELLANEOUS DATA (OCLC); PIECE USED FOR CATALOGING (pre-AACR2) (RLIN)', 'OCLC/CONSER MISCELLANEOUS DATA (OCLC); PIECE USED FOR CATALOGING (pre-AACR2) (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('940', 'EQUIVALENCE OR CROSS-REFERENCE--UNIFORM TITLE [OBSOLETE] [CAN/MARC only]', 'EQUIVALENCE OR CROSS-REFERENCE--UNIFORM TITLE [OBSOLETE] [CAN/MARC only]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('941', 'EQUIVALENCE OR CROSS-REFERENCE--ROMANIZED TITLE [OBSOLETE] [CAN/MARC only]', 'EQUIVALENCE OR CROSS-REFERENCE--ROMANIZED TITLE [OBSOLETE] [CAN/MARC only]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('943', 'EQUIVALENCE OR CROSS-REFERENCE--COLLECTIVE TITLE [OBSOLETE] [CAN/MARC only]', 'EQUIVALENCE OR CROSS-REFERENCE--COLLECTIVE TITLE [OBSOLETE] [CAN/MARC only]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('945', 'LOCAL PROCESSING INFORMATION (OCLC)', 'LOCAL PROCESSING INFORMATION (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('94c', 'EQUIVALENCE OR CROSS-REFERENCE--TITLE [OBSOLETE] [CAN/MARC only]', 'EQUIVALENCE OR CROSS-REFERENCE--TITLE [OBSOLETE] [CAN/MARC only]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('946', 'LOCAL PROCESSING INFORMATION (OCLC)', 'LOCAL PROCESSING INFORMATION (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('947', 'LOCAL PROCESSING INFORMATION (OCLC)', 'LOCAL PROCESSING INFORMATION (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('948', 'LOCAL PROCESSING INFORMATION (OCLC); SERIES PART DESIGNATOR (RLIN)', 'LOCAL PROCESSING INFORMATION (OCLC); SERIES PART DESIGNATOR (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('949', 'LOCAL PROCESSING INFORMATION (OCLC)', 'LOCAL PROCESSING INFORMATION (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('94a', 'ANALYSIS TREATMENT NOTE (RLIN)', 'ANALYSIS TREATMENT NOTE (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('94b', 'TREATMENT CODES (RLIN)', 'TREATMENT CODES (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('950', 'LOCAL HOLDINGS (RLIN)', 'LOCAL HOLDINGS (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('951', 'EQUIVALENCE OR CROSS-REFERENCE--GEOGRAPHIC NAME/AREA NAME [OBSOLETE] [CAN/MARC only]', 'EQUIVALENCE OR CROSS-REFERENCE-GEOGRAPHIC NAME/AREA NAME [OBSOLETE] [CAN/MARC only]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('95c', 'EQUIVALENCE OR CROSS-REFERENCE--HIERARCHICAL PLACE NAME [OBSOLETE] [CAN/MARC only]', 'EQUIVALENCE OR CROSS-REFERENCE-HIERARCHICAL PLACE NAME [OBSOLETE] [CAN/MARC only]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('95r', 'CLUSTER MEMBER (RLIN)', 'CLUSTER MEMBER (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('955', 'COPY-LEVEL INFORMATION (RLIN)', 'COPY-LEVEL INFORMATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('956', 'LOCAL ELECTRONIC LOCATION AND ACCESS (OCLC)', 'LOCAL ELECTRONIC LOCATION AND ACCESS (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('960', 'PHYSICAL LOCATION (RLIN)', 'PHYSICAL LOCATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('967', 'ADDITIONAL ESTC CODES (RLIN)', 'ADDITIONAL ESTC CODES (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('980', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--PERSONAL NAME/TITLE [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--PERSONAL NAME/TITLE [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('981', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--CORPORATE NAME/TITLE [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--CORPORATE NAME/TITLE [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('982', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--CONFERENCE OR MEETING NAME/TITLE [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--CONFERENCE OR MEETING NAME/TITLE [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('983', 'EQUIVALENCE OR CROSS-REFERENCE-SERIES STATEMENT--TITLE/UNIFORM TITLE [LOCAL, CANADA]', 'EQUIVALENCE OR CROSS-REFERENCE--SERIES STATEMENT-TITLE/UNIFORM TITLE [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('984', 'WLN AUTOMATIC HOLDINGS STATEMENT (OCLC)', 'WLN AUTOMATIC HOLDINGS STATEMENT (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('987', 'LOCAL ROMANIZATION/CONVERSION HISTORY (OCLC)', 'LOCAL ROMANIZATION/CONVERSION HISTORY (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('990', 'EQUIVALENCES OR CROSS-REFERENCES [LOCAL, CANADA]', 'EQUIVALENCES OR CROSS-REFERENCES [LOCAL, CANADA]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('995', 'RECOMMANDATION 995 [LOCAL, UNIMARC FRANCE]', 'RECOMMANDATION 995 [LOCAL, UNIMARC FRANCE]', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('998', 'LOCAL CONTROL INFORMATION (RLIN)', 'LOCAL CONTROL INFORMATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('999', '090: LOCALLY ASSIGNED LC-TYPE CALL NUMBER (OCLC); LOCAL CALL NUMBER (RLIN)', '090: LOCALLY ASSIGNED LC-TYPE CALL NUMBER (OCLC); LOCAL CALL NUMBER (OCLC)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('b99', 'PRIVATE LOCAL INFORMATION (RLIN)', 'PRIVATE LOCAL INFORMATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u01', 'UNIT IDENTIFICATION, STATUS, AND TYPE (RLIN)', 'UNIT IDENTIFICATION, STATUS, AND TYPE (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u02', 'STANDARD NUMBER (RLIN)', 'STANDARD NUMBER (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u08', 'CODED INFORMATION (RLIN)', 'CODED INFORMATION (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u10', 'REQUESTER IDENTIFICATION (RLIN)', 'REQUESTER IDENTIFICATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u11', 'DEPARTMENT REPORT REQUEST (RLIN)', 'DEPARTMENT REPORT REQUEST (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u20', 'SUPPLIER IDENTIFICATION, SUPN (RLIN)', 'SUPPLIER IDENTIFICATION, SUPN (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u21', 'LIBRARY CODES FOR VENDOR AND ORDER (RLIN)', 'LIBRARY CODES FOR VENDOR AND ORDER (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u22', 'SUPPLIER CODES AND CATALOG INFORMATION (RLIN)', 'SUPPLIER CODES AND CATALOG INFORMATION (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u25', 'SUPPLIER REPORT(S) (RLIN)', 'SUPPLIER REPORT(S) (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u30', 'INTERVALS (RLIN)', 'INTERVALS (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u31', 'CLAIM COUNTS (RLIN)', 'CLAIM COUNTS (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u33', 'INVOICE CLAIM (RLIN)', 'INVOICE CLAIM (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u34', 'EXTENDED PROCUREMENT CLAIM AND REVIEW (RLIN)', 'EXTENDED PROCUREMENT CLAIM AND REVIEW (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u40', 'EXTENDED PROCUREMENT CODES (RLIN)', 'EXTENDED PROCUREMENT CODES (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u50', 'ACQUISITIONS NOTES (RLIN)', 'ACQUISITIONS NOTES (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u51', 'SELECTION NOTES (RLIN)', 'SELECTION NOTES (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u52', 'SUPPLIER INSTRUCTIONS AND NOTES, SINT (RLIN)', 'SUPPLIER INSTRUCTIONS AND NOTES, SINT (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u53', 'CLAIM INSTRUCTIONS AND NOTES, CLNT (RLIN)', 'CLAIM INSTRUCTIONS AND NOTES, CLNT (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u54', 'NOTES TO SERIALS DEPARTMENT (RLIN)', 'NOTES TO SERIALS DEPARTMENT (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u55', 'CATALOGING NOTES (RLIN)', 'CATALOGING NOTES (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u5f', 'ACCOUNTING NOTES (RLIN)', 'ACCOUNTING NOTES (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u70', 'MATERIAL AND LOCATION INFORMATION (RLIN)', 'MATERIAL AND LOCATION INFORMATION (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u71', 'FUND ACCOUNT (RLIN)', 'FUND ACCOUNT (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u75', 'ITEM DETAILS (RLIN)', 'ITEM DETAILS (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u7f', 'PRICE INFORMATION (RLIN)', 'PRICE INFORMATION (RLIN)', 1, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('u90', 'TAPE OUTPUT, TAPE (RLIN)', 'TAPE OUTPUT, TAPE (RLIN)', 0, 0, '', '');
INSERT INTO `marc_tag_structure` VALUES ('ufi', 'FISCAL INFORMATION, FI (RLIN)', 'FISCAL INFORMATION, FI (RLIN)', 1, 0, '', '');



INSERT INTO `marc_subfield_structure` VALUES ('000', '@', 'fixed length control field', 'fixed length control field', 0, 1, '', 0, '', '', 'marc21_leader.pl', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('001', '@', 'control field', 'control field', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('003', '@', 'control field', 'control field', 0, 1, '', 0, '', '', 'marc21_field_003.pl', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('005', '@', 'control field', 'control field', 0, 1, '', 0, '', '', 'marc21_field_005.pl', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('006', '@', 'fixed length control field', 'fixed length control field', 0, 0, '', 0, '', '', 'marc21_field_006.pl', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('007', '@', 'fixed length control field', 'fixed length control field', 0, 0, '', 0, '', '', 'marc21_field_007.pl', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('008', '@', 'fixed length control field', 'fixed length control field', 0, 1, '', 0, '', '', 'marc21_field_008.pl', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('009', '@', 'fixed length control field', 'fixed length control field', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('010', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', NULL, 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('010', 'a', 'LC control number', 'LC control number', 0, 0, 'biblioitems.lccn', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('010', 'b', 'NUCMC control number', 'NUCMC control number', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('010', 'z', 'Canceled/invalid LC control number', 'Canceled/invalid LC control number', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('011', 'a', 'LC control number', 'LC control number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', NULL, 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', 'a', 'Number', 'Number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', 'b', 'Country', 'Country', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', 'c', 'Type of number', 'Type of number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', 'd', 'Date', 'Date', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', 'e', 'Status', 'Status', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('013', 'f', 'Party to document', 'Party to document', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('015', '2', 'Source', 'Source', 0, 0, '', 0, '', '', NULL, 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('015', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('015', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('015', 'a', 'National bibliography number', 'National bibliography number', 1, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('016', '2', 'Source', 'Source', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('016', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('016', 'a', 'Record control number', 'Record control number', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('016', 'z', 'Canceled or invalid record control number', 'Canceled or invalid record control number', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', '2', 'Source', 'Source', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', 'a', 'Copyright or legal deposit number', 'Copyright or legal deposit number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', 'b', 'Assigning agency', 'Assigning agency', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', 'd', 'Date', 'Date', 0, 0, '', 0, '', '', NULL, 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('017', 'i', 'Display text', 'Display text', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('018', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('018', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('018', 'a', 'Copyright article-fee code', 'Copyright article-fee code', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('01e', 'a', 'Coded field error', 'Coded field error', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('020', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('020', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('020', 'a', 'International Standard Book Number', 'International Standard Book Number', 0, 0, 'biblioitems.isbn', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('020', 'c', 'Terms of availability', 'Terms of availability', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('020', 'z', 'Cancelled/invalid ISBN', 'Cancelled/invalid ISBN', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('022', '2', 'Source', 'Source', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('022', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('022', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('022', 'a', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, 'biblioitems.issn', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('022', 'y', 'Incorrect ISSN', 'Incorrect ISSN', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('022', 'z', 'Canceled ISSN', 'Canceled ISSN', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('023', 'a', 'Standard film number', 'Standard film number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', '2', 'Source of number or code', 'Source of number or code', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', 'a', 'Standard number or code', 'Standard number or code', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', 'b', 'Additional codes following the standard number [OBSOLETE]', 'Additional codes following the standard number [OBSOLETE]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', 'c', 'Terms of availability', 'Terms of availability', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', 'd', 'Additional codes following the standard number or code', 'Additional codes following the standard number or code', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('024', 'z', 'Canceled/invalid standard number or code', 'Canceled/invalid standard number or code', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('025', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('025', 'a', 'Overseas acquisition number', 'Overseas acquisition number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', '2', 'Source', 'Source', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', '5', 'Institution to which field applies', 'Institution to which field applies', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', 'a', 'First and second groups of characters', 'First and second groups of characters', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', 'b', 'Third and fourth groups of characters', 'Third and fourth groups of characters', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', 'c', 'Date', 'Date', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', 'd', 'Number of volume or part', 'Number of volume or part', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('026', 'e', 'unparsed fingerprint', 'unparsed fingerprint', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('027', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('027', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('027', 'a', 'Standard technical report number', 'Standard technical report number', 0, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('027', 'z', 'Canceled/invalid number', 'Canceled/invalid number', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('028', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('028', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('028', 'a', 'Publisher number', 'Publisher number', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('028', 'b', 'Source', 'Source', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('030', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('030', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('030', 'a', 'CODEN', 'CODEN', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('030', 'z', 'Canceled/invalid CODEN', 'Canceled/invalid CODEN', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', '2', 'System code', 'System code', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'a', 'Number of work', 'Number of work', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'b', 'Number of movement', 'Number of movement', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'c', 'Number of excerpt', 'Number of excerpt', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'd', 'Caption or heading', 'Caption or heading', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'e', 'Role', 'Role', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'g', 'Clef', 'Clef', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'm', 'Voice/instrument', 'Voice/instrument', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'n', 'Key signature', 'Key signature', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'o', 'Time signature', 'Time signature', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'p', 'Musical notation', 'Musical notation', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'q', 'General note', 'General note', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'r', 'Key or mode', 'Key or mode', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 's', 'Coded validity note', 'Coded validity note', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 't', 'Text incipit', 'Text incipit', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 0, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'y', 'Link text', 'Link text', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('031', 'z', 'Public note', 'Public note', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('032', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', NULL, 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('032', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('032', 'a', 'Postal registration number', 'Postal registration number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('032', 'b', 'Source (agency assigning number)', 'Source (agency assigning number)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('033', '3', 'Materials specified', 'Materials specified', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('033', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('033', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('033', 'a', 'Formatted date/time', 'Formatted date/time', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('033', 'b', 'Geographic classification area code', 'Geographic classification area code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('033', 'c', 'Geographic classification subarea code', 'Geographic classification subarea code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'a', 'Category of scale', 'Category of scale', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'b', 'Constant ratio linear horizontal scale', 'Constant ratio linear horizontal scale', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'c', 'Constant ratio linear vertical scale', 'Constant ratio linear vertical scale', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'd', 'Coordinates--westernmost longitude', 'Coordinates--westernmost longitude', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'e', 'Coordinates--easternmost longitude', 'Coordinates--easternmost longitude', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'f', 'Coordinates--northernmost latitude', 'Coordinates--northernmost latitude', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'g', 'Coordinates--southernmost latitude', 'Coordinates--southernmost latitude', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'h', 'Angular scale', 'Angular scale', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'j', 'Declination--northern limit', 'Declination--northern limit', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'k', 'Declination--southern limit', 'Declination--southern limit', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'm', 'Right ascension--eastern limit', 'Right ascension--eastern limit', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'n', 'Right ascension--western limit', 'Right ascension--western limit', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 'p', 'Equinox', 'Equinox', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 's', 'G-ring latitude', 'G-ring latitude', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('034', 't', 'G-ring longitude', 'G-ring longitude', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('035', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('035', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('035', 'a', 'System control number', 'System control number', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('035', 'z', 'Canceled/invalid control number', 'Canceled/invalid control number', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('036', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('036', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('036', 'a', 'Original study number', 'Original study number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('036', 'b', 'Source (agency assigning number)', 'Source (agency assigning number)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', 'a', 'Stock number', 'Stock number', 0, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', 'b', 'Source of stock number/acquisition', 'Source of stock number/acquisition', 0, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', 'c', 'Terms of availability', 'Terms of availability', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', 'f', 'Form of issue', 'Form of issue', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', 'g', 'Additional format characteristics', 'Additional format characteristics', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('037', 'n', 'Note', 'Note', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('038', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('038', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('038', 'a', 'Record content licensor', 'Record content licensor', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('039', 'a', 'Level of rules in bibliographic description', 'Level of rules in bibliographic description', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('039', 'b', 'Level of effort used to assign nonsubject heading access points', 'Level of effort used to assign nonsubject heading access points', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('039', 'c', 'Level of effort used to assign subject headings', 'Level of effort used to assign subject headings', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('039', 'd', 'Level of effort used to assign classification', 'Level of effort used to assign classification', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('039', 'e', 'Number of fixed field character positions coded', 'Number of fixed field character positions coded', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', 'a', 'Original cataloging agency', 'Original cataloging agency', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', 'b', 'Language of cataloging', 'Language of cataloging', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', 'c', 'Transcribing agency', 'Transcribing agency', 0, 1, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', 'd', 'Modifying agency', 'Modifying agency', 1, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('040', 'e', 'Description conventions', 'Description conventions', 0, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', '2', 'Source of code', 'Source of code', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'a', 'Language code of text/sound track or separate title', 'Language code of text/sound track or separate title', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'b', 'Language code of summary or abstract/overprinted title or subtitle', 'Language code of summary or abstract/overprinted title or subtitle', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'c', 'Languages of separate titles (VM) [OBSOLETE] ; Languages of available translation  (SE) [OBSOLETE]', 'Languages of separate titles (VM) [OBSOLETE] ; Languages of available translation  (SE) [OBSOLETE]', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'd', 'Language code of sung or spoken text', 'Language code of sung or spoken text', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'e', 'Language code of librettos', 'Language code of librettos', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'f', 'Language code of table of contents', 'Language code of table of contents', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'g', 'Language code of accompanying material other than librettos', 'Language code of accompanying material other than librettos', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('041', 'h', 'Language code of original and/or intermediate translations of text', 'Language code of original and/or intermediate translations of text', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('042', 'a', 'Authentication code', 'Authentication code', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('043', '2', 'Source of local code', 'Source of local code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('043', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('043', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('043', 'a', 'Geographic area code', 'Geographic area code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('043', 'b', 'Local GAC code', 'Local GAC code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('043', 'c', 'ISO code', 'ISO code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('044', '2', 'Source of local subentity code', 'Source of local subentity code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('044', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('044', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('044', 'a', 'MARC country code', 'MARC country code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('044', 'b', 'Local subentity code', 'Local subentity code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('044', 'c', 'ISO country code', 'ISO country code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('045', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('045', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('045', 'a', 'Time period code', 'Time period code', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('045', 'b', 'Formatted 9999 B.C. through C.E. time period', 'Formatted 9999 B.C. through C.E. time period', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('045', 'c', 'Formatted pre-9999 B.C. time period', 'Formatted pre-9999 B.C. time period', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', '2', 'Source of date', 'Source of date', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'a', 'Type of date code', 'Type of date code', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'b', 'Date 1 (B.C. date)', 'Date 1 (B.C. date)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'c', 'Date 1 (C.E. date)', 'Date 1 (C.E. date)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'd', 'Date 2 (B.C. date)', 'Date 2 (B.C. date)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'e', 'Date 2 (C.E. date)', 'Date 2 (C.E. date)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'j', 'Date resource modified', 'Date resource modified', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'k', 'Beginning or single date created', 'Beginning or single date created', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'l', 'Ending date created', 'Ending date created', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'm', 'Beginning of date valid', 'Beginning of date valid', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('046', 'n', 'End of date valid', 'End of date valid', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('047', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('047', 'a', 'Form of musical composition code', 'Form of musical composition code', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('048', '2', 'Source of code', 'Source of code', 0, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('048', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('048', 'a', 'Performer or ensemble', 'Performer or ensemble', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('048', 'b', 'Soloist', 'Soloist', 1, 0, '', 0, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'a', 'Holding library', 'Holding library', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'c', 'Copy statement', 'Copy statement', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'd', 'Definition of bibliographic subdivisions', 'Definition of bibliographic subdivisions', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'l', 'Local processing data', 'Local processing data', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'm', 'Missing elements', 'Missing elements', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'n', 'Notes about holdings', 'Notes about holdings', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'o', 'Local processing data', 'Local processing data', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'p', 'Secondary bibliographic subdivision', 'Secondary bibliographic subdivision', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'q', 'Third bibliographic subdivision', 'Third bibliographic subdivision', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'r', 'Fourth bibliographic subdivision', 'Fourth bibliographic subdivision', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 's', 'Fifth bibliographic subdivision', 'Fifth bibliographic subdivision', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 't', 'Sixth bibliographic subdivision', 'Sixth bibliographic subdivision', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'u', 'Seventh bibliographic subdivision', 'Seventh bibliographic subdivision', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'v', 'Primary bibliographic subdivision', 'Primary bibliographic subdivision', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('049', 'y', 'Inclusive dates of publication or coverage', 'Inclusive dates of publication or coverage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('050', '3', 'Materials specified', 'Materials specified', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('050', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('050', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('050', 'a', 'Classification number', 'Classification number', 1, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('050', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('050', 'd', 'Supplementary class number (MU) [OBSOLETE]', 'Supplementary class number (MU) [OBSOLETE]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('051', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('051', 'a', 'Classification number', 'Classification number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('051', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('051', 'c', 'Copy information', 'Copy information', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', '2', 'Code Source', 'Code Source', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', 'a', 'Geographic classification area code', 'Geographic classification area code', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', 'b', 'Geographic classification subarea code', 'Geographic classification subarea code', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', 'c', 'Subject (MP) [OBSOLETE]', 'Subject (MP) [OBSOLETE]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('052', 'd', 'Populated place name', 'Populated place name', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('055', '2', 'Source of call/class number', 'Source of call/class number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('055', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('055', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('055', 'a', 'Classification number', 'Classification number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('055', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('060', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('060', 'a', 'Classification number', 'Classification number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('060', 'b', 'Item number', 'Item number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('061', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('061', 'a', 'Classification number', 'Classification number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('061', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('061', 'c', 'Copy information', 'Copy information', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('066', 'a', 'Primary G0 character set', 'Primary G0 character set', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('066', 'b', 'Primary G1 character set', 'Primary G1 character set', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('066', 'c', 'Alternate G0 or G1 character set', 'Alternate G0 or G1 character set', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('070', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('070', 'a', 'Classification number', 'Classification number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('070', 'b', 'Item number', 'Item number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('071', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('071', 'a', 'Classification number', 'Classification number', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('071', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('071', 'c', 'Copy information', 'Copy information', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('072', '2', 'Source', 'Source', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('072', '6', 'Linkage', 'Linkage', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('072', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('072', 'a', 'Subject category code', 'Subject category code', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('072', 'x', 'Subject category code subdivision', 'Subject category code subdivision', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('074', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('074', 'a', 'GPO item number', 'GPO item number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('074', 'z', 'Canceled/invalid GPO item number', 'Canceled/invalid GPO item number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('080', '2', 'Edition identifier', 'Edition identifier', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('080', '6', 'Linkage', 'Linkage', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('080', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('080', 'a', 'Universal Decimal Classification number', 'Universal Decimal Classification number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('080', 'b', 'Item number', 'Item number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('080', 'x', 'Common auxiliary subdivision', 'Common auxiliary subdivision', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('082', '2', 'Edition number', 'Edition number', 0, 0, '', 0, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('082', '6', 'Linkage', 'Linkage', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('082', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('082', 'a', 'Classification number', 'Classification number', 1, 0, '', 0, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('082', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('084', '2', 'Source of number', 'Source of number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('084', '6', 'Linkage', 'Linkage', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('084', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('084', 'a', 'Classification number', 'Classification number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('084', 'b', 'Item number', 'Item number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('086', '2', 'Number source', 'Number source', 0, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('086', '6', 'Linkage', 'Linkage', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('086', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('086', 'a', 'Classification number', 'Classification number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('086', 'z', 'Canceled/invalid classification number', 'Canceled/invalid classification number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('087', 'a', 'Report number [OBSOLETE, CAN/MARC]', 'Report number [OBSOLETE, CAN/MARC]', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('087', 'z', 'Canceled/invalid report number [OBSOLETE, CAN/MARC]', 'Canceled/invalid report number [OBSOLETE, CAN/MARC]', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('088', '6', 'Linkage', 'Linkage', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('088', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('088', 'a', 'Report number', 'Report number', 0, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('088', 'z', 'Canceled/invalid report number', 'Canceled/invalid report number', 1, 0, NULL, 0, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'a', 'Classification number (OCLC) (R) ; Classification number, CALL (RLIN) (NR)', 'Classification number (OCLC) (R) ; Classification number, CALL (RLIN) (NR)', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'b', 'Local cutter number (OCLC) ; Book number/undivided call number, CALL (RLIN)', 'Local cutter number (OCLC) ; Book number/undivided call number, CALL (RLIN)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'e', 'Feature heading (OCLC)', 'Feature heading (OCLC)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'f', 'Filing suffix (OCLC); Footnote, FNT (RLIN)', 'Filing suffix (OCLC); Footnote, FNT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'h', 'Output transaction history, HST (RLIN)', 'Output transaction history, HST (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'i', 'Output transaction instruction, INS (RLIN)', 'Output transaction instruction, INS (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'l', 'Extra card control statement, EXT (RLIN)', 'Extra card control statement, EXT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'n', 'Additional local notes, ANT (RLIN)', 'Additional local notes, ANT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'p', 'Pathfinder code, PTH (RLIN)', 'Pathfinder code, PTH (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 't', 'Field suppresion, FSP (RLIN)', 'Field suppresion, FSP (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'v', 'Volumes, VOL (RLIN)', 'Volumes, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'y', 'Date, VOL (RLIN)', 'Date, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('09o', 'z', 'Retention, VOL (RLIN)', 'Retention, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('091', 'a', 'Microfilm shelf location', 'Microfilm shelf location', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('092', '2', 'Edition number', 'Edition number', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('092', 'a', 'Classification number', 'Classification number', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('092', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('092', 'e', 'Feature heading', 'Feature heading', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('092', 'f', 'Filing suffix', 'Filing suffix', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('096', 'a', 'Classification number', 'Classification number', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('096', 'b', 'Item number', 'Item number', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('096', 'e', 'Feature heading', 'Feature heading', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('096', 'f', 'Filing suffix', 'Filing suffix', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('098', 'a', 'Call number based on other classification scheme', 'Call number based on other classification scheme', 0, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('098', 'e', 'Feature heading', 'Feature heading', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('098', 'f', 'Filing suffix', 'Filing suffix', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('099', 'a', 'Classification number', 'Classification number', 1, 0, '', 0, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('099', 'e', 'Feature heading', 'Feature heading', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('099', 'f', 'Filing suffix', 'Filing suffix', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', '4', 'Relator code', 'Relator code', 1, 0, '', 1, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', '6', 'Linkage', 'Linkage', 0, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'a', 'Personal name', 'Personal name', 0, 0, 'biblio.author', 1, '', '', '', 0, 0, '', '''100b'',''100c'',''100q'',''100d'',''100e'',''110a'',''110b'',''110c'',''110d'',''110e'',''700a'',''700b'',''700c'',''700q'',''700d'',''700e'',''710a'',''710b'',''710c'',''710d'',''710e'',''720a'',''720e'',''900a''', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'b', 'Numeration', 'Numeration', 0, 0, '', 1, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 1, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 1, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'e', 'Relator term', 'Relator term', 1, 0, '', 1, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 1, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 't', 'Title of a work', 'Title of a work', 0, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('100', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 1, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', '4', 'Relator code', 'Relator code', 1, 0, '', 1, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', '6', 'Linkage', 'Linkage', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 1, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 1, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 1, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 1, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'e', 'Relator term', 'Relator term', 1, 0, '', 1, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 't', 'Title of a work', 'Title of a work', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('110', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', '4', 'Relator code', 'Relator code', 1, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', '6', 'Linkage', 'Linkage', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'b', 'Number [OBSOLETE]', 'Number [OBSOLETE]', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 1, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('111', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', '6', 'Linkage', 'Linkage', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'a', 'Uniform title', 'Uniform title', 0, 0, NULL, 1, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'h', 'Medium', 'Medium', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 1, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 'r', 'Key for music', 'Key for music', 0, 0, NULL, 1, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 's', 'Version', 'Version', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('130', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('210', '2', 'Source', 'Source', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('210', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('210', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('210', 'a', 'Abbreviated title', 'Abbreviated title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('210', 'b', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('211', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('211', 'a', 'Acronym or shortened title', 'Acronym or shortened title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('212', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('212', 'a', 'Variant access title', 'Variant access title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('214', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('214', 'a', 'Augmented title', 'Augmented title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('222', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('222', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('222', 'a', 'Key title', 'Key title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('222', 'b', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'a', 'Uniform title', 'Uniform title', 0, 0, 'biblio.unititle', 2, '', '', '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'h', 'Medium', 'Medium', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 'r', 'Key for music', 'Key for music', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('240', 's', 'Version', 'Version', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('241', 'a', 'Romanized title', 'Romanized title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('241', 'h', 'Medium', 'Medium', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'a', 'Title', 'Title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'b', 'Remainder of title', 'Remainder of title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'c', 'Statement of responsibility, etc', 'Statement of responsibility, etc', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'd', 'Designation of section (BK AM MP MU VM SE) [OBSOLETE]', 'Designation of section (BK AM MP MU VM SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'e', 'Name of part/section (BK AM MP MU VM SE) [OBSOLETE]', 'Name of part/section (BK AM MP MU VM SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'h', 'Medium', 'Medium', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('242', 'y', 'Language code of translated title', 'Language code of translated title', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'a', 'Uniform title', 'Unifor title', 0, 0, '', 2, '', '', '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'h', 'Medium', 'Medium', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 'r', 'Key for music', 'Key for music', 0, 0, '', 2, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('243', 's', 'Version', 'Version', 0, 0, '', 2, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'a', 'Title', 'Title', 0, 1, 'biblio.title', 2, '', '', '', NULL, 0, '', '''245b'',''245f'',''245g'',''245k'',''245n'',''245p'',''245s'',''245h'',''246i'',''246a'',''246b'',''246f'',''246g'',''246n'',''246p'',''246h'',''242a'',''242b'',''242n'',''242p'',''242h''', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'b', 'Remainder of title', 'Remainder of title', 0, 0, 'bibliosubtitle.subtitle', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'c', 'Statement of responsibility, etc', 'Statement of responsibility, etc', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'd', 'Designation of section/part/series (SE) [OBSOLETE]', 'Designation of section section/part/series: (SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'e', 'Name of part/section/series (SE) [OBSOLETE]', 'Name of part/section/series (SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'f', 'Inclusive dates', 'Inclusive dates', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'g', 'Bulk dates', 'Bulk dates', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'h', 'Medium', 'Medium', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'k', 'Form', 'Form', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('245', 's', 'Version', 'Version', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'a', 'Title proper/short title', 'Title proper/short title', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'b', 'Remainder of title', 'Remainder of title', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'd', 'Designation of section/part/series (SE) [OBSOLETE]', 'Designation of section section/part/series (SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'e', 'Name of part/section/series (SE) [OBSOLETE]', 'Name of part/section/series (SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'f', 'Date or sequential designation', 'Date or sequential designation', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'h', 'Medium', 'Medium', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'i', 'Display text', 'Display text', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('246', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'a', 'Title', 'Title', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'b', 'Remainder of title', 'Remainder of title', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'd', 'Designation of section (SE) [OBSOLETE]', 'Designation of section (SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'e', 'Name of part/section (SE) [OBSOLETE]', 'Name of part/section (SE) [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'f', 'Date or sequential designation', 'Date or sequential designation', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'h', 'Medium', 'Medium', 0, 0, '', 2, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('247', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('250', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('250', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('250', 'a', 'Edition statement', 'Edition statement', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('250', 'b', 'Remainder of edition statement', 'Remainder of edition statement', 0, 0, '', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('254', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('254', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('254', 'a', 'Musical presentation statement', 'Musical presentation statement', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'a', 'Statement of scale', 'Statement of scale', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'b', 'Statement of projection', 'Statement of projection', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'c', 'Statement of coordinates', 'Statement of coordinates', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'd', 'Statement of zone', 'Statement of zone', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'e', 'Statement of equinox', 'Statement of equinox', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'f', 'Outer G-ring coordinate pairs', 'Outer G-ring coordinate pairs', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('255', 'g', 'Exclusion G-ring coordinate pairs', 'Exclusion G-ring coordinate pairs', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('256', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('256', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('256', 'a', 'Computer file characteristics', 'Computer file characteristics', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('257', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('257', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('257', 'a', 'Country of producing entity', 'Country of producing entity', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('258', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('258', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('258', 'a', 'Issuing jurisdiction', 'Issuing jurisdiction', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('258', 'b', 'Denomination', 'Denomination', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'a', 'Place of publication, distribution, etc', 'Place of publication, distribution, etc', 1, 0, 'biblioitems.place', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'b', 'Name of publisher, distributor, etc', 'Name of publisher, distributor, etc', 1, 0, 'biblioitems.publishercode', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'c', 'Date of publication, distribution, etc', 'Date of publication, distribution, etc', 1, 0, 'biblio.copyrightdate', 2, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'd', 'Plate or publisher\'s number for music (Pre-AACR 2) [OBSOLETE, CAN/MARC], [LOCAL, USA]', 'Plate or publisher\'s number for music (Pre-AACR 2) [OBSOLETE, CAN/MARC], [LOCAL, USA]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'e', 'Place of manufacture', 'Place of manufacture', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'f', 'Manufacturer', 'Manufacturer', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'g', 'Date of manufacture', 'Date of manufacture', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'k', 'Identification/manufacturer number [OBSOLETE, CAN/MARC]', 'Identification/manufacturer number [OBSOLETE, CAN/MARC]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('260', 'l', 'Matrix and/or take number [OBSOLETE, CAN/MARC]', 'Matrix and/or take number [OBSOLETE, CAN/MARC]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', 'a', 'Producing company', 'Producing company', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', 'b', 'Releasing company (primary distributor)', 'Releasing company (primary distributor)', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', 'c', 'Date of production, release, etc.', 'Date of production, release, etc.', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', 'd', 'Date of production, release, etc.', 'Date of production, release, etc.', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', 'e', 'Contractual producer', 'Contractual producer', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('261', 'f', 'Place of production, release, etc.', 'Place of production, release, etc.', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', 'a', 'Place of production, release, etc.', 'Place of production, release, etc.', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', 'b', 'Publisher or trade name', 'Publisher or trade name', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', 'c', 'Date of production, release, etc.', 'Date of production, release, etc.', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', 'k', 'Serial identification', 'Serial identification', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('262', 'l', 'Matrix and/or take number', 'Matrix and/or take number', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('263', '6', 'Linkage', 'Linkage', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('263', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('263', 'a', 'Projected publication date', 'Projected publication date', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('265', '6', 'Linkage [OBSOLETE]', 'Linkage [OBSOLETE]', 0, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('265', 'a', 'Source for acquisition/subscription address [OBSOLETE]', 'Source for acquisition/subscription address [OBSOLETE]', 1, 0, '', 2, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', '4', 'Relator code', 'Relator code', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', '6', 'Linkage', 'Linkage', 0, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'a', 'Address', 'Address', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'b', 'City', 'City', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'c', 'State or province', 'State or province', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'd', 'Country', 'Country', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'e', 'Postal code', 'Postal code', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'f', 'Terms preceding attention name', 'Terms preceding attention name', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'g', 'Attention name', 'Attention name', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'h', 'Attention position', 'Attention position', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'i', 'Type of address', 'Type of address', 0, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'j', 'Specialized telephone number', 'Specialized telephone number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'k', 'Telephone number', 'Telephone number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'l', 'Fax number', 'Fax number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'm', 'Electronic mail address', 'Electronic mail address', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'n', 'TDD or TTY number', 'TDD or TTY number', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'p', 'Contact person', 'Contact person', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'q', 'Title of contact person', 'Title of contact person', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'r', 'Hours', 'Hours', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('270', 'z', 'Public note', 'Public note', 1, 0, NULL, 2, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', '3', 'Materials specified', 'Materials specified', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'a', 'Extent', 'Extent', 1, 1, 'biblioitems.pages', 3, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'b', 'Other physical details', 'Other physical details', 0, 0, 'biblioitems.illus', 3, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'c', 'Dimensions', 'Dimensions', 1, 0, 'biblioitems.size', 3, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'd', 'Accompanying material [OBSOLETE, CAN/MARC]', 'Accompanying material [OBSOLETE, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'e', 'Accompanying material', 'Accompanying material', 0, 0, '', 3, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'f', 'Type of unit', 'Type of unit', 1, 0, '', 3, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'g', 'Size of unit', 'Size of unit', 1, 0, '', 3, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'k', 'Speed [Videodiscs, pre-AACR2 records only] [OBSOLETE, CAN/MARC]', 'Speed [Videodiscs, pre-AACR2 records only] [OBSOLETE, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'm', 'Identification/manufacturer number [pre-AACR2 records only] [OBSOLETE, CAN/MARC]', 'Identification/manufacturer number [pre-AACR2 records only] [OBSOLETE, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('300', 'n', 'Matrix and/or take number [Sound recordings, pre-AACR2 records only] [OBSOLETE, CAN/MARC]', 'Matrix and/or take number [Sound recordings, pre-AACR2 records only] [OBSOLETE, CAN/MARC]', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('301', 'a', 'Extent of item', 'Extent of item', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('301', 'b', 'Sound characteristics', 'Sound characteristics', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('301', 'c', 'Color characteristics', 'Color characteristics', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('301', 'd', 'Dimensions', 'Dimensions', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('301', 'e', 'Sound characteristics', 'Sound characteristics', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('301', 'f', 'Speed', 'Speed', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('302', 'a', 'Page count', 'Page count', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('303', 'a', 'Unit count', 'Unit count', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('304', 'a', 'Linear footage', 'Linear footage', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'a', 'Extent', 'Extent', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'b', 'Other physical details', 'Other physical details', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'c', 'Dimensions', 'Dimensions', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'd', 'Microgroove or standard', 'Microgroove or standard', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'e', 'Stereophonic, monaural', 'Stereophonic, monaural', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'f', 'Number of tracks', 'Number of tracks', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'm', 'Serial identification', 'Serial identification', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('305', 'n', 'Matrix and/or take number', 'Matrix and/or take number', 0, 0, '', 3, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('306', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('306', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('306', 'a', 'Playing time', 'Playing time', 0, 0, '', 3, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('307', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('307', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('307', 'a', 'Hours', 'Hours', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('307', 'b', 'Additional information', 'Additional information', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', 'a', 'Number of reels', 'Number of reels', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', 'b', 'Footage', 'Footage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', 'c', 'Sound characteristics', 'Sound characteristics', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', 'd', 'Color characteristics', 'Color characteristics', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', 'e', 'Width', 'Width', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('308', 'f', 'Presentation format', 'Presentation format', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('310', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('310', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('310', 'a', 'Current publication frequency', 'Current publication frequency', 0, 0, NULL, 3, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('310', 'b', 'Date of current publication frequency', 'Date of current publication frequency', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('315', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('315', 'a', 'Frequency', 'Frequency', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('315', 'b', 'Dates of frequency', 'Dates of frequency', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('321', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('321', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('321', 'a', 'Former publication frequency', 'Former publication frequency', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('321', 'b', 'Former publication frequency', 'Former publication frequency', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', '3', 'Materials specified', 'Materials specified', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'a', 'Material base and configuration', 'Material base and configuration', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'b', 'Dimensions', 'Dimensions', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'c', 'Materials applied to surface', 'Materials applied to surface', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'd', 'Information recording technique', 'Information recording technique', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'e', 'Support', 'Support', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'f', 'Production rate/ratio', 'Production rate/ratio', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'h', 'Location within medium', 'Location within medium', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('340', 'i', 'Technical specifications of medium', 'Technical specifications of medium', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', '2', 'Reference method used', 'Reference method used', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'a', 'Name', 'Name', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'b', 'Coordinate or distance units', 'Coordinate or distance units', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'c', 'Latitude resolution', 'Latitude resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'd', 'Longitude resolution', 'Longitude resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'e', 'Standard parallel or oblique line latitude', 'Standard parallel or oblique line latitude', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'f', 'Oblique line longitude', 'Oblique line longitude', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'g', 'Longitude of central meridian or projection center', 'Longitude of central meridian or projection center', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'h', 'Latitude of projection origin or projection center', 'Latitude of projection origin or projection center', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'i', 'False easting', 'False easting', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'j', 'False northing', 'False northing', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'k', 'Scale factor', 'Scale factor', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'l', 'Height of perspective point above surface', 'Height of perspective point above surface', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'm', 'Azimuthal angle', 'Azimuthal angle', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'n', 'Azimuth measure point longitude or straight vertical longitude from pole', 'Azimuth measure point longitude or straight vertical longitude from pole', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'o', 'Landsat number and path number', 'Landsat number and path number', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'p', 'Zone identifier', 'Zone identifier', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'q', 'Ellipsoid name', 'Ellipsoid name', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'r', 'Semi-major axis', 'Semi-major axis', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 's', 'Denominator of flattening ratio', 'Denominator of flattening ratio', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 't', 'Vertical resolution', 'Vertical resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'u', 'Vertical encoding method', 'Vertical encoding method', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'v', 'Local planar, local, or other projection or grid description', 'Local planar, local, or other projection or grid description', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('342', 'w', 'Local planar or local georeference information', 'Local planar or local georeference information', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'a', 'Planar coordinate encoding method', 'Planar coordinate encoding method', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'b', 'Planar distance units', 'Planar distance units', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'c', 'Abscissa resolution', 'Abscissa resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'd', 'Ordinate resolution', 'Ordinate resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'e', 'Distance resolution', 'Distance resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'f', 'Bearing resolution', 'Bearing resolution', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'g', 'Bearing unit', 'Bearing unit', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'h', 'Bearing reference direction', 'Bearing reference direction', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('343', 'i', 'Bearing reference meridian', 'Bearing reference meridian', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('350', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('350', 'a', 'Price', 'Price', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('350', 'b', 'Form of issue', 'Form of issue', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('351', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('351', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('351', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('351', 'a', 'Organization', 'Organization', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('351', 'b', 'Arrangement', 'Arrangement', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('351', 'c', 'Hierarchical level', 'Hierarchical level', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'a', 'Direct reference method', 'Direct reference method', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'b', 'Object type', 'Object type', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'c', 'Object count', 'Object count', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'd', 'Row count', 'Row count', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'e', 'Column count', 'Column count', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'f', 'Vertical count', 'Vertical count', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'g', 'VPF topology level', 'VPF topology level', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('352', 'i', 'Indirect reference description', 'Indirect reference description', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'a', 'Security classification', 'Security classification', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'b', 'Handling instructions', 'Handling instructions', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'c', 'External dissemination information', 'External dissemination information', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'd', 'Downgrading or declassification event', 'Downgrading or declassification event', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'e', 'Classification system', 'Classification system', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'f', 'Country of origin code', 'Country of origin code', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'g', 'Downgrading date', 'Downgrading date', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'h', 'Declassification date', 'Declassification date', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('355', 'j', 'Authorization', 'Authorization', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('357', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('357', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('357', 'a', 'Originator control term', 'Originator control term', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('357', 'b', 'Originating agency', 'Originating agency', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('357', 'c', 'Authorized recipients of material', 'Authorized recipients of material', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('357', 'g', 'Other restrictions', 'Other restrictions', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('359', 'a', 'Rental price', 'Rental price', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('362', '6', 'Linkage', 'Linkage', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('362', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('362', 'a', 'Dates of publication and/or sequential designation', 'Dates of publication and/or sequential designation', 0, 0, 'biblioitems.volumedesc', 3, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('362', 'z', 'Source of information', 'Source of information', 0, 0, NULL, 3, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', '2', 'Source of price type code', 'Source of price type code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'a', 'Price type code', 'Price type code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'b', 'Price amount', 'Price amount', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'c', 'Price type code', 'Price type code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'd', 'Unit of pricing', 'Unit of pricing', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'e', 'Price note', 'Price note', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'f', 'Price effective from', 'Price effective from', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'g', 'Price effective until', 'Price effective until', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'h', 'Tax rate 1', 'Tax rate 1', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'i', 'Tax rate 2', 'Tax rate 2', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'j', 'ISO country code', 'ISO country code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'k', 'MARC country code', 'MARC country code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('365', 'm', 'Identification of pricing entity', 'Identification of pricing entity', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', '2', 'Source of availability status code', 'Source of availability status code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', '6', 'Linkage', 'Linkage', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'a', 'Publishers\' compressed title identification', 'Publishers\' compressed title identification', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'b', 'Detailed date of publication', 'Detailed date of publication', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'c', 'Availability status code', 'Availability status code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'd', 'Expected next availability date', 'Expected next availability date', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'e', 'Note', 'Note', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'f', 'Publishers\' discount category', 'Publishers\' discount category', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'g', 'Date made out of print', 'Date made out of print', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'j', 'ISO country code', 'ISO country code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'k', 'MARC country code', 'MARC country code', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('366', 'm', 'Identification of agency', 'Identification of agency', 0, 0, '', 3, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', '4', 'Relator code', 'Relator code', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', '6', 'Linkage', 'Linkage', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'a', 'Personal name', 'Personal name', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'b', 'Numeration', 'Numeration', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'e', 'Relator term', 'Relator term', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 't', 'Title of a work', 'Title of a work', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 4, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('400', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', '4', 'Relator code', 'Relator code', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', '6', 'Linkage', 'Linkage', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'e', 'Relator term', 'Relator term', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 't', 'Title of a work', 'Title of a work', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('410', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', '4', 'Relator code', 'Relator code', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', '6', 'Linkage', 'Linkage', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'b', 'Number [OBSOLETE]', 'Number [OBSOLETE]', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 4, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('411', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', '6', 'Linkage', 'Linkage', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', 'a', 'Title', 'Title', 0, 0, 'biblio.seriestitle', 4, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, 'biblioitems.number', 4, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 4, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, 'biblioitems.volume', 4, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('440', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 4, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('490', '6', 'Linkage', 'Linkage', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('490', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 4, '', '', NULL, NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('490', 'a', 'Series statement', 'Series statement', 1, 0, '', 4, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('490', 'l', 'Library of Congress call number', 'Library of Congress call number', 0, 0, '', 4, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('490', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 1, 0, '', 4, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('490', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 4, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', '3', 'Materials specified', 'Materials specified', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', 'a', 'General note', 'General note', 0, 0, 'biblio.notes', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', 'l', 'Library of Congress call number (SE) [OBSOLETE]', 'Library of Congress call number (SE) [OBSOLETE]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', 'n', 'n (RLIN) [OBSOLETE]', 'n (RLIN) [OBSOLETE]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', 'x', 'International Standard Serial Number (SE) [OBSOLETE]', 'International Standard Serial Number (SE) [OBSOLETE]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('500', 'z', 'Source of note information (AM SE) [OBSOLETE]', 'Source of note information (AM SE) [OBSOLETE]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('501', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('501', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('501', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('501', 'a', 'With note', 'With note', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('502', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('502', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('502', 'a', 'Dissertation note', 'Dissertation note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('503', '8', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('503', 'a', 'Bibliographic history note', 'Bibliographic history note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('504', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('504', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('504', 'a', 'Bibliography, etc', 'Bibliography, etc', 0, 0, '', 5, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('504', 'b', 'Number of references', 'Number of references', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', 'a', 'Formatted contents note', 'Formatted contents note', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', 'g', 'Miscellaneous information', 'Miscellaneous information', 1, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', 'r', 'Statement of responsibility', 'Statement of responsibility', 1, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', 't', 'Title', 'Title', 1, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('505', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', '3', 'Materials specified', 'Materials specified', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', 'a', 'Terms governing access', 'Terms governing access', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', 'b', 'Jurisdiction', 'Jurisdiction', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', 'c', 'Physical access provisions', 'Physical access provisions', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', 'd', 'Authorized users', 'Authorized users', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', 'e', 'Authorization', 'Authorization', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('506', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('507', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('507', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('507', 'a', 'Representative fraction of scale note', 'Representative fraction of scale note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('507', 'b', 'Remainder of scale note', 'Remainder of scale note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('508', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('508', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('508', 'a', 'Creation/production credits note', 'Creation/production credits note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('509', 'a', 'Informal Notes', 'Informal Notes', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', '3', 'Materials specified', 'Materials specified', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', 'a', 'Name of source', 'Name of source', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', 'b', 'Coverage of source', 'Coverage of source', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', 'c', 'Location within source', 'Location within source', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('510', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('511', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('511', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('511', 'a', 'Participant or performer note', 'Participant or performer note', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('512', '6', 'Linkage', 'Linkage', 0, 0, '', -1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('512', 'a', 'Earlier or later volumes separately cataloged note', 'Earlier or later volumes separately cataloged note', 0, 0, '', -1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('513', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('513', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('513', 'a', 'Type of report', 'Type of report', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('513', 'b', 'Period covered', 'Period covered', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'a', 'Attribute accuracy report', 'Attribute accuracy report', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'b', 'Attribute accuracy value', 'Attribute accuracy value', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'c', 'Attribute accuracy explanation', 'Attribute accuracy explanation', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'd', 'Logical consistency report', 'Logical consistency report', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'e', 'Completeness report', 'Completeness report', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'f', 'Horizontal position accuracy report', 'Horizontal position accuracy report', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'g', 'Horizontal position accuracy value', 'Horizontal position accuracy value', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'h', 'Horizontal position accuracy explanation', 'Horizontal position accuracy explanation', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'i', 'Vertical positional accuracy report', 'Vertical positional accuracy report', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'j', 'Vertical positional accuracy value', 'Vertical positional accuracy value', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'k', 'Vertical positional accuracy explanation', 'Vertical positional accuracy explanation', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'm', 'Cloud cover', 'Cloud cover', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('514', 'z', 'Display note', 'Display note', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('515', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('515', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('515', 'a', 'Numbering peculiarities note', 'Numbering peculiarities note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('515', 'z', 'Source of note information (SE) [OBSOLETE]', 'Source of note information (SE) [OBSOLETE]', 0, 0, '', -1, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('516', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('516', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('516', 'a', 'Type of computer file or data note', 'Type of computer file or data note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('517', 'a', 'Different formats', 'Different formats', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('517', 'b', 'Content descriptors', 'Content descriptors', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('517', 'c', 'Additional animation techniques', 'Additional animation techniques', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('518', '3', 'Materials specified', 'Materials specified', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('518', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('518', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('518', 'a', 'Date/time and place of an event note', 'Date/time and place of an event note', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', '3', 'Materials specified', 'Materials specified', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', 'a', 'Summary, etc', 'Summary, etc', 0, 0, 'biblio.abstract', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', 'b', 'Expansion of summary note', 'Expansion of summary note', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('520', 'z', 'Source of note information [OBSOLETE]', 'Source of note information [OBSOLETE]', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('521', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('521', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('521', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('521', 'a', 'Target audience note', 'Target audience note', 1, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('521', 'b', 'Source', 'Source', 0, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('522', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('522', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('522', 'a', 'Geographic coverage note', 'Geographic coverage note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('523', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('523', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('523', 'a', 'Time period of content note', 'Time period of content note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('524', '2', 'Source of schema used', 'Source of schema used', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('524', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('524', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('524', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('524', 'a', 'Preferred citation of described materials note', 'Preferred citation of described materials note', 0, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('525', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('525', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('525', 'a', 'Supplement note', 'Supplement note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('525', 'z', 'Source of note information (SE) [OBSOLETE]', 'Source of note information (SE) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'a', 'Program name', 'Program name', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'b', 'Interest level', 'Interest level', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'c', 'Reading level', 'Reading level', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'd', 'Title point value', 'Title point value', 0, 0, '', 5, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'i', 'Display text', 'Display text', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 5, '', '', '', NULL, 6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('526', 'z', 'Public note', 'Public note', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('527', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('527', 'a', 'Censorship note', 'Censorship note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', 'a', 'Additional physical form available note', 'Additional physical form available note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', 'b', 'Availability source', 'Availability source', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', 'c', 'Availability conditions', 'Availability conditions', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', 'd', 'Order number', 'Order number', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, NULL, 5, NULL, NULL, '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('530', 'z', 'Source of note information (AM CF VM SE) [OBSOLETE]', 'Source of note information (AM CF VM SE) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', '7', 'Fixed-length data elements of reproduction', 'Fixed-length data elements of reproduction', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'a', 'Type of reproduction', 'Type of reproduction', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'b', 'Place of reproduction', 'Place of reproduction', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'c', 'Agency responsible for reproduction', 'Agency responsible for reproduction', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'd', 'Date of reproduction', 'Date of reproduction', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'e', 'Physical description of reproduction', 'Physical description of reproduction', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'f', 'Series statement of reproduction', 'Series statement of reproduction', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'm', 'Dates and/or sequential designation of issues reproduced', 'Dates and/or sequential designation of issues reproduced', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('533', 'n', 'Note about reproduction', 'Note about reproduction', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'a', 'Main entry of original', 'Main entry of original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'b', 'Edition statement of original', 'Edition statement of original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'c', 'Publication, distribution, etc', 'Publication, distribution, etc', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'e', 'Physical description, etc', 'Physical description, etc', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'f', 'Series statement of original', 'Series statement of original', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'k', 'Key title of original', 'Key title of original', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'l', 'Location of original', 'Location of original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'm', 'Material specific details', 'Material specific details', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'n', 'Note about original', 'Note about original', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'p', 'Introductory phrase', 'Introductory phrase', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 't', 'Title statement of original', 'Title statement of original', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('534', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', 'a', 'Custodian', 'Custodian', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', 'b', 'Postal address', 'Postal address', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', 'c', 'Country', 'Country', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', 'd', 'Telecommunications address', 'Telecommunications address', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('535', 'g', 'Repository location code', 'Repository location code', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'a', 'Text of note', 'Text of note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'b', 'Contract number', 'Contract number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'c', 'Grant number', 'Grant number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'd', 'Undifferentiated number', 'Undifferentiated number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'e', 'Program element number', 'Program element number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'f', 'Project number', 'Project number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'g', 'Task number', 'Task number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('536', 'h', 'Work unit number', 'Work unit number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('537', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('537', 'a', 'Source of data note', 'Source of data note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('538', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('538', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('538', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('538', 'a', 'System details note', 'System details note', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('538', 'i', 'Display text', 'Display text', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('538', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', 'a', 'Terms governing use and reproduction', 'Terms governing use and reproduction', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', 'b', 'Jurisdiction', 'Jurisdiction', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', 'c', 'Authorization', 'Authorization', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', 'd', 'Authorized users', 'Authorized users', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('540', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'a', 'Source of acquisition', 'Source of acquisition', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'b', 'Address', 'Address', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'c', 'Method of acquisition', 'Method of acquisition', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'd', 'Date of acquisition', 'Date of acquisition', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'e', 'Accession number', 'Accession number', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'f', 'Owner', 'Owner', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'h', 'Purchase price', 'Purchase price', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'n', 'Extent', 'Extent', 0, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('541', 'o', 'Type of unit', 'Type of unit', 1, 0, '', 5, '', '', '', NULL, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('543', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('543', 'a', 'Solicitation information note', 'Solicitation information note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', 'a', 'Custodian', 'Custodian', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', 'b', 'Address', 'Address', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', 'c', 'Country', 'Country', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', 'd', 'Title', 'Title', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', 'e', 'Provenance', 'Provenance', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('544', 'n', 'Note', 'Note', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('545', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('545', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('545', 'a', 'Biographical or historical note', 'Biographical or historical note', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('545', 'b', 'Expansion', 'Expansion', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('545', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('546', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('546', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('546', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('546', 'a', 'Language note', 'Language note', 0, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('546', 'b', 'Information code or alphabet', 'Information code or alphabet', 1, 0, NULL, 5, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('546', 'z', 'Source of note information (SE) [OBSOLETE]', 'Source of note information (SE) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('547', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('547', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('547', 'a', 'Former title complexity note', 'Former title complexity note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('547', 'z', 'Source of note information (SE) [OBSOLETE]', 'Source of note information (SE) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('550', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('550', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('550', 'a', 'Issuing body note', 'Issuing body note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('550', 'z', 'Source of note information (SE) [OBSOLETE]', 'Source of note information (SE) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'a', 'Entity type label', 'Entity type label', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'b', 'Entity type definition and source', 'Entity type definition and source', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'c', 'Attribute label', 'Attribute label', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'd', 'Attribute definition and source', 'Attribute definition and source', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'e', 'Enumerated domain value', 'Enumerated domain value', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'f', 'Enumerated domain value definition and source', 'Enumerated domain value definition and source', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'g', 'Range domain minimum and maximum', 'Range domain minimum and maximum', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'h', 'Codeset name and source', 'Codeset name and source', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'i', 'Unrepresentable domain', 'Unrepresentable domain', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'j', 'Attribute units of measurement and resolution', 'Attribute units of measurement and resolution', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'k', 'Beginning date and ending date of attribute values', 'Beginning date and ending date of attribute values', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'l', 'Attribute value accuracy', 'Attribute value accuracy', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'm', 'Attribute value accuracy explanation', 'Attribute value accuracy explanation', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'n', 'Attribute measurement frequency', 'Attribute measurement frequency', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'o', 'Entity and attribute overview', 'Entity and attribute overview', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'p', 'Entity and attribute detail citation', 'Entity and attribute detail citation', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('552', 'z', 'Display note', 'Display note', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', 'a', 'Cumulative index/finding aids note', 'Cumulative index/finding aids note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', 'b', 'Availability source', 'Availability source', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', 'c', 'Degree of control', 'Degree of control', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', 'd', 'Bibliographic reference', 'Bibliographic reference', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('555', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, NULL, 5, NULL, NULL, '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('556', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('556', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('556', 'a', 'Information about documentation note', 'Information about documentation note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('556', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('561', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('561', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('561', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('561', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('561', 'a', 'History', 'History', 0, 0, '', 5, '', '', '', NULL, 6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('561', 'b', 'Time of collation [OBSOLETE]', 'Time of collation [OBSOLETE]', 0, 0, '', 5, '', '', '', NULL, 6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', 'a', 'Identifying markings', 'Identifying markings', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', 'b', 'Copy identification', 'Copy identification', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', 'c', 'Version identification', 'Version identification', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', 'd', 'Presentation format', 'Presentation format', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('562', 'e', 'Number of copies', 'Number of copies', 1, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('563', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('563', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('563', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('563', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('563', 'a', 'Binding note', 'Binding note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('563', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, NULL, 5, NULL, NULL, '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', 'a', 'Number of cases/variables', 'Number of cases/variables', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', 'b', 'Name of variable', 'Name of variable', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', 'c', 'Unit of analysis', 'Unit of analysis', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', 'd', 'Universe of data', 'Universe of data', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('565', 'e', 'Filing scheme or code', 'Filing scheme or code', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('567', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('567', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('567', 'a', 'Methodology note', 'Methodology note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('570', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('570', 'a', 'Editor note', 'Editor note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('570', 'z', 'Source of note information', 'Source of note information', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('580', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('580', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('580', 'a', 'Linking entry complexity note', 'Linking entry complexity note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('580', 'z', 'Source of note information [OBSOLETE]', 'Source of note information [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('581', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('581', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('581', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('581', 'a', 'Publications about described materials note', 'Publications about described materials note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('581', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('582', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('582', 'a', 'Related computer files note', 'Related computer files note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', '2', 'Source of term', 'Source of term', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'a', 'Action', 'Action', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'b', 'Action identification', 'Action identification', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'c', 'Time/date of action', 'Time/date of action', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'd', 'Action interval', 'Action interval', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'e', 'Contingency for action', 'Contingency for action', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'f', 'Authorization', 'Authorization', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'h', 'Jurisdiction', 'Jurisdiction', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'i', 'Method of action', 'Method of action', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'j', 'Site of action', 'Site of action', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'k', 'Action agent', 'Action agent', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'l', 'Status', 'Status', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'n', 'Extent', 'Extent', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'o', 'Type of unit', 'Type of unit', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 5, '', '', '', 1, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 5, '', '', '', NULL, 4, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('583', 'z', 'Public note', 'Public note', 1, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('584', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('584', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('584', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('584', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('584', 'a', 'Accumulation', 'Accumulation', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('584', 'b', 'Frequency of use', 'Frequency of use', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('585', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('585', '5', 'Institution to which field applies', 'Institution to which field applies', 0, -6, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('585', '6', 'Linkage', 'Linkage', 0, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('585', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 5, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('585', 'a', 'Exhibitions note', 'Exhibitions note', 0, 0, '', 5, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('586', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('586', '6', 'Linkage', 'Linkage', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('586', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('586', 'a', 'Awards note', 'Awards note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('590', '6', 'Linkage (RLIN)', 'Linkage (RLIN)', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('590', '8', 'Field link and sequence number (RLIN)', 'Field link and sequence number (RLIN)', 1, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('590', 'a', 'Local note', 'Local note', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('590', 'b', 'Provenance (VM) [OBSOLETE]', 'Provenance (VM) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('590', 'c', 'Condition of individual reels (VM) [OBSOLETE]', 'Condition of individual reels (VM) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('590', 'd', 'Origin of safety copy (VM) [OBSOLETE]', 'Origin of safety copy (VM) [OBSOLETE]', 0, 0, NULL, 5, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'a', 'Personal name', 'Personal name', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'b', 'Numeration', 'Numeration', 0, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'h', 'Medium', 'Medium', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'r', 'Key for music', 'Key for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 's', 'Version', 'Version', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 't', 'Title of a work', 'Title of a work', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('600', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'h', 'Medium', 'Medium', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'r', 'Key for music', 'Key for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 's', 'Version', 'Version', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 't', 'Title of a work', 'Title of a work', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('610', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', '4', 'Relator code', 'Relator code', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', '6', 'Linkage', 'Linkage', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'b', 'Number  (BK CF MP MU SE VM MX)  [OBSOLETE]', 'Number  (BK CF MP MU SE VM MX)  [OBSOLETE]', 1, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'h', 'Medium', 'Medium', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 's', 'Version', 'Version', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'v', 'Form subdivision', 'Form subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'x', 'General subdivision', 'General subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('611', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, NULL, 6, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', '4', 'Relator code', 'Relator code', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', '6', 'Linkage', 'Linkage', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'a', 'Uniform title', 'Uniform title', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'h', 'Medium', 'Medium', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'r', 'Key for music', 'Key for music', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 's', 'Version', 'Version', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'v', 'Form subdivision', 'Form subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'x', 'General subdivision', 'General subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('630', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', '6', 'Linkage', 'Linkage', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', 'a', 'Chronological term', 'Chronological term', 0, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', 'v', 'Form subdivision', 'Form subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', 'x', 'General subdivision', 'General subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('648', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', '4', 'Relator code', 'Relator code', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'a', 'Topical term or geographic name as entry element', 'Topical term or geographic name as entry element', 0, 0, 'bibliosubject.subject', 6, '', '', '', 0, 0, '', '''6003'',''600a'',''600b'',''600c'',''600d'',''600e'',''600f'',''600g'',''600h'',''600k'',''600l'',''600m'',''600n'',''600o'',''600p'',''600r'',''600s'',''600t'',''600u'',''600x'',''600z'',''600y'',''600v'',''6103'',''610a'',''610b'',''610c'',''610d'',''610e'',''610f'',''610g'',''610h'',''610k'',''610l'',''610m'',''610n'',''610o'',''610p'',''610r'',''610s'',''610t'',''610u'',''610x'',''610z'',''610y'',''610v'',''6113'',''611a'',''611b'',''611c'',''611d'',''611e'',''611f'',''611g'',''611h'',''611k'',''611l'',''611m'',''611n'',''611o'',''611p'',''611r'',''611s'',''611t'',''611u'',''611x'',''611z'',''611y'',''611v'',''630a'',''630b'',''630c'',''630d'',''630e'',''630f'',''630g'',''630h'',''630k'',''630l'',''630m'',''630n'',''630o'',''630p'',''630r'',''630s'',''630t'',''630x'',''630z'',''630y'',''630v'',''6483'',''648a'',''648x'',''648z'',''648y'',''648v'',''6503'',''650b'',''650c'',''650d'',''650e'',''650x'',''650z'',''650y'',''650v'',''6513'',''651a'',''651b'',''651c'',''651d'',''651e'',''651x'',''651z'',''651y'',''651v'',''653a'',''6543'',''654a'',''654b'',''654x'',''654z'',''654y'',''654v'',''6553'',''655a'',''655b'',''655x'',''655z'',''655y'',''655v'',''6563'',''656a'',''656k'',''656x'',''656z'',''656y'',''656v'',''6573'',''657a'',''657x'',''657z'',''657y'',''657v'',''658a'',''658b'',''658c'',''658d'',''658v''', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'b', 'Topical term following geographic name as entry element', 'Topical term following geographic name as entry element', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'c', 'Location of event', 'Location of event', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'd', 'Active dates', 'Active dates', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'e', 'Relator term', 'Relator term', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('650', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'a', 'Geographic name', 'Geographic name', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'b', 'Geographic name following place entry element [OBSOLETE]', 'Geographic name following place entry element [OBSOLETE]', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('651', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('652', 'a', 'Geographic name of place element', 'Geographic name of place element', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('652', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('652', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('652', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('653', '6', 'Linkage', 'Linkage', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('653', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('653', 'a', 'Uncontrolled term', 'Uncontrolled term', 1, 0, NULL, 6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', '2', 'Source of term', 'Source of term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'a', 'Focus term', 'Focus term', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'b', 'Non-focus term', 'Non-focus term', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'c', 'Facet/hierarchy designation', 'Facet/hierarchy designation', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('654', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', '2', 'Source of term', 'Source of term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'a', 'Genre/form data or focus term', 'Genre/form data or focus term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'b', 'Non-focus term', 'Non-focus term', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'c', 'Facet/hierarchy designation', 'Facet/hierarchy designation', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('655', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', '2', 'Source of term', 'Source of term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', 'a', 'Occupation', 'Occupation', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', 'k', 'Form', 'Form', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('656', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', '2', 'Source of term', 'Source of term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', 'a', 'Function', 'Function', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('657', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', '2', 'Source of term', 'Source of term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', 'a', 'Main curriculum objective', 'Main curriculum objective', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', 'b', 'Subordinate curriculum objective', 'Subordinate curriculum objective', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', 'c', 'Curriculum code', 'Curriculum code', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('658', 'd', 'Correlation factor', 'Correlation factor', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', '2', 'Source of term', 'Source of term', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'a', 'Country or larger entity', 'Country or larger entity', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'b', 'First-order political jurisdiction', 'First-order political jurisdiction', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'c', 'Intermediate political jurisdiction', 'Intermediate political jurisdiction', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'd', 'City', 'City', 0, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'f', 'City subsection', 'City subsection', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'g', 'Other nonjurisdictional geographic region and feature', 'Other nonjurisdictional geographic region and feature', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('662', 'h', 'Extraterrestrial area', 'Extraterrestrial area', 1, 0, '', 6, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'a', 'Topical term or geographic name as entry element', 'Topical term or geographic name as entry element', 0, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'b', 'Topical term following geographic name as entry element', 'Topical term following geographic name as entry element', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'c', 'Location of event', 'Location of event', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'd', 'Active dates', 'Active dates', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'e', 'Relator term', 'Relator term', 0, 0, '', 6, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('690', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', 'a', 'Geographic name', 'Geographic name', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', 'b', 'Geographic name following place entry element [OBSOLETE]', 'Geographic name following place entry element [OBSOLETE]', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('691', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'a', 'Personal name', 'Personal name', 0, 0, '', 3, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'b', 'Numeration', 'Numeration', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'h', 'Medium', 'Medium', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'r', 'Key for music', 'Key for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 's', 'Version', 'Version', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 't', 'Title of a work', 'Title of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('696', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '4', 'Relator code', 'Relator code', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'e', 'Relator term', 'Relator term', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'h', 'Medium', 'Medium', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'r', 'Key for music', 'Key for music', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 's', 'Version', 'Version', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 't', 'Title of a work', 'Title of a work', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('697', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '4', 'Relator code', 'Relator code', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '6', 'Linkage', 'Linkage', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'b', 'Number  (BK CF MP MU SE VM MX)  [OBSOLETE]', 'Number  (BK CF MP MU SE VM MX)  [OBSOLETE]', 1, 0, NULL, -1, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'h', 'Medium', 'Medium', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 's', 'Version', 'Version', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'v', 'Form subdivision', 'Form subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'x', 'General subdivision', 'General subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('698', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 6, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', '6', 'Linkage', 'Linkage', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 6, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'a', 'Uniform title', 'Uniform title', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'h', 'Medium', 'Medium', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'r', 'Key for music', 'Key for music', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 's', 'Version', 'Version', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'v', 'Form subdivision', 'Form subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'x', 'General subdivision', 'General subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('699', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, NULL, 6, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', '4', 'Relator code', 'Relator code', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'a', 'Personal name', 'Personal name', 0, 0, 'additionalauthors.author', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'b', 'Numeration', 'Numeration', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'e', 'Relator term', 'Relator term', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('700', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'a', 'Personal name', 'Personal name', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'b', 'Numeration', 'Numeration', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'e', 'Relator term', 'Relator term', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('705', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', '4', 'Relator code', 'Relator code', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'e', 'Relator term', 'Relator term', 1, 0, '', 7, '', '', '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('710', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', '4', 'Relator code', 'Relator code', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'b', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'h', 'Medium', 'Medium', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 's', 'Version', 'Version', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('711', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'a', 'Corporate name or jurisdiction name', 'Corporate name or jurisdiction name', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'b', 'Subordinate unit', 'Subordinate unit', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'e', 'Relator term', 'Relator term', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'h', 'Medium', 'Medium', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'r', 'Key for music', 'Key for music', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 's', 'Version', 'Version', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('715', 'u', 'Nonprinting information', 'Nonprinting information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('720', '4', 'Relator code', 'Relator code', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('720', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('720', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('720', 'a', 'Name', 'Name', 0, 0, '', 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('720', 'e', 'Relator term', 'Relator term', 1, 0, NULL, 7, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('730', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', 'a', 'Uncontrolled related/analytical title', 'Uncontrolled related/analytical title', 0, 0, '', 7, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('740', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'a', 'Country or larger entity', 'Country or larger entity', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'b', 'First-order political jurisdiction', 'First-order political jurisdiction', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'c', 'Intermediate political jurisdiction', 'Intermediate political jurisdiction', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'd', 'City', 'City', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'f', 'City subsection', 'City subsection', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'g', 'Other nonjurisdictional geographic region and feature', 'Other nonjurisdictional geographic region and feature', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('752', 'h', 'Extraterrestrial area', 'Extraterrestrial area', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('753', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('753', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('753', 'a', 'Make and model of machine', 'Make and model of machine', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('753', 'b', 'Programming language', 'Programming language', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('753', 'c', 'Operating system', 'Operating system', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', '2', 'Source of taxonomic identification', 'Source of taxonomic identification', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', 'a', 'Taxonomic name', 'Taxonomic name', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', 'c', 'Taxonomic category', 'Taxonomic category', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', 'd', 'Common or alternative name', 'Common or alternative name', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', 'x', 'Non-public note', 'Non-public note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('754', 'z', 'Public note', 'Public note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', '2', 'Source of taxonomic identification', 'Source of taxonomic identification', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', 'a', 'Access term', 'Access term', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('755', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'b', 'Edition', 'Edition', 0, 0, NULL, -6, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('760', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('762', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'q', 'Parallel title (BK SE)  [OBSOLETE]', 'Parallel title (BK SE)  [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('765', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('767', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', '8', 'Field link and sequence number', 'Field link and sequence number ', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('770', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('772', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'p', 'Abbreviated title', 'Abbreviated title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('773', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('774', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'e', 'Language code', 'Language code', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'f', 'Country code', 'Country code', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('775', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('776', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('777', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('780', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('785', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'j', 'Period of content', 'Period of content', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'p', 'Abbreviated title', 'Abbreviated title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('786', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', '7', 'Control subfield', 'Control subfield', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'a', 'Main entry heading', 'Main entry heading', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'b', 'Edition', 'Edition', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'c', 'Qualifying information', 'Qualifying information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'd', 'Place, publisher, and date of publication', 'Place, publisher, and date of publication', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'g', 'Relationship information', 'Relationship information', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'h', 'Physical description', 'Physical description', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'i', 'Display text', 'Display text', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'k', 'Series data for related item', 'Series data for related item', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'm', 'Material-specific details', 'Material-specific details', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'n', 'Note', 'Note', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'o', 'Other item identifier', 'Other item identifier', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'q', 'Parallel title (BK SE) [OBSOLETE]', 'Parallel title (BK SE) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'r', 'Report number', 'Report number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 's', 'Uniform title', 'Uniform title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 't', 'Title', 'Title', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'u', 'Standard Technical Report Number', 'Standard Technical Report Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'w', 'Record control number', 'Record control number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'y', 'CODEN designation', 'CODEN designation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('787', 'z', 'International Standard Book Number', 'International Standard Book Number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '%', '%', '%', 0, 0, '', 7, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '2', '2', '2', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '3', '3', '3', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '4', '4', '4', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '5', '5', '5', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '6', '6', '6', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '7', '7', '7', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '8', '8', '8', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', '9', '9', '9', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'a', 'a', 'a', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'b', 'b', 'b', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'c', 'c', 'c', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'd', 'd', 'd', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'e', 'e', 'e', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'f', 'f', 'f', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'g', 'g', 'g', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'h', 'h', 'h', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'i', 'i', 'i', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'j', 'j', 'j', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'k', 'k', 'k', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'l', 'l', 'l', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'm', 'm', 'm', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'n', 'n', 'n', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'o', 'o', 'o', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'p', 'p', 'p', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'q', 'q', 'q', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'r', 'r', 'r', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 's', 's', 's', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 't', 't', 't', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'u', 'u', 'u', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'v', 'v', 'v', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'w', 'w', 'w', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'x', 'x', 'x', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'y', 'y', 'y', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('789', 'z', 'z', 'z', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '4', 'Relator code', 'Relator code', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'a', 'Personal name', 'Personal name', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'b', 'Numeration', 'Numeration', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'e', 'Relator term', 'Relator term', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('796', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '4', 'Relator code', 'Relator code', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'e', 'Relator term', 'Relator term', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('797', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '4', 'Relator code', 'Relator code', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '6', 'Linkage', 'Linkage', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'b', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'h', 'Medium', 'Medium', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 's', 'Version', 'Version', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('798', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, NULL, 7, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 7, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', '3', 'Materials specified', 'Materials specified', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', '6', 'Linkage', 'Linkage', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 7, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'h', 'Medium', 'Medium', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'r', 'Key for music', 'Key for music', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 's', 'Version', 'Version', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 't', 'Title of a work', 'Title of a work', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('799', 'x', 'International Standard Serial Number', 'International Standard Serial Number', 0, 0, '', 7, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', '4', 'Relator code', 'Relator code', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'a', 'Personal name', 'Personal name', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'b', 'Numeration', 'Numeration', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'e', 'Relator term', 'Relator term', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('800', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', '4', 'Relator code', 'Relator code', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'e', 'Relator term', 'Relator term', 1, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('810', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', '4', 'Relator code', 'Relator code', 1, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', '8', 'Field link and sequence number ', 'Field link and sequence number ', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'b', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 8, NULL, NULL, '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'h', 'Medium', 'Medium', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 's', 'Version', 'Version', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('811', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('830', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('840', 'a', 'Title', 'Title', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('840', 'h', 'Medium', 'Medium', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('840', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('841', 'a', 'Type of record', 'Type of record', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('841', 'b', 'Fixed-length data elements', 'Fixed-length data elements', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('841', 'e', 'Encoding level', 'Encoding level', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('842', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('842', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('842', 'a', 'Textual physical form designator', 'Textual physical form designator', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', '7', 'Fixed-length data elements of reproduction', 'Fixed-length data elements of reproduction', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'a', 'Type of reproduction', 'Type of reproduction', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'b', 'Place of reproduction', 'Place of reproduction', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'c', 'Agency responsible for reproduction', 'Agency responsible for reproduction', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'd', 'Date of reproduction', 'Date of reproduction', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'e', 'Physical description of reproduction', 'Physical description of reproduction', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'f', 'Series statement of reproduction', 'Series statement of reproduction', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'm', 'Dates of publication and/or sequential designation of issues reproduced', 'Dates of publication and/or sequential designation of issues reproduced', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('843', 'n', 'Note about reproduction', 'Note about reproduction', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('844', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('844', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('844', 'a', 'Name of unit', 'Name of unit', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', '5', 'Institution to which field applies', 'Institution to which field applies', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', 'a', 'Terms governing use and reproduction', 'Terms governing use and reproduction', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', 'b', 'Jurisdiction', 'Jurisdiction', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', 'c', 'Authorization', 'Authorization', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('845', 'd', 'Authorized users', 'Authorized users', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('850', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('850', 'a', 'Holding institution', 'Holding institution', 1, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('850', 'b', 'Holdings (NR) (MU VM SE) [OBSOLETE]', 'Holdings (NR) (MU VM SE) [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('850', 'd', 'Inclusive dates (NR) (MU VM SE) [OBSOLETE]', 'Inclusive dates (NR) (MU VM SE) [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('850', 'e', 'Retention statement (NR) (CF MU VM SE) [OBSOLETE]', 'Retention statement (NR) (CF MU VM SE) [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', '3', 'Materials specified', 'Materials specified', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'a', 'Name (custodian or owner)', 'Name (custodian or owner)', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'b', 'Institutional division', 'Institutional division', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'c', 'Street address', 'Street address', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'd', 'Country', 'Country', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'e', 'Location of units', 'Location of units', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'f', 'Item number', 'Item number', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('851', 'g', 'Repository location code', 'Repository location code', 0, 0, NULL, 8, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', '2', 'Source of classification or shelving scheme', 'Source of classification or shelving scheme', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', '8', 'Sequence number', 'Sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'a', 'Location', 'Location', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'b', 'Sublocation or collection', 'Sublocation or collection', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'c', 'Shelving location', 'Shelving location', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'e', 'Address', 'Address', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'f', 'Coded location qualifier', 'Coded location qualifier', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'g', 'Non-coded location qualifier', 'Non-coded location qualifier', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'h', 'Classification part', 'Classification part', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'i', 'Item part', 'Item part', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'j', 'Shelving control number', 'Shelving control number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'k', 'Call number prefix', 'Call number prefix', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'l', 'Shelving form of title', 'Shelving form of title', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'm', 'Call number suffix', 'Call number suffix', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'n', 'Country code', 'Country code', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'p', 'Piece designation', 'Piece designation', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'q', 'Piece physical condition', 'Piece physical condition', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 's', 'Copyright article-fee code', 'Copyright article-fee code', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 't', 'Copy number', 'Copy number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('852', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'a', 'First level of enumeration', 'First level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'b', 'Second level of enumeration', 'Second level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'c', 'Third level of enumeration', 'Third level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'd', 'Fourth level of enumeration', 'Fourth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'e', 'Fifth level of enumeration', 'Fifth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'f', 'Sixth level of enumeration', 'Sixth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'g', 'Alternative numbering scheme, first level of enumeration', 'Alternative numbering scheme, first level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'h', 'Alternative numbering scheme, second level of enumeration', 'Alternative numbering scheme, second level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'i', 'First level of chronology', 'First level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'j', 'Second level of chronology', 'Second level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'k', 'Third level of chronology', 'Third level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'l', 'Fourth level of chronology', 'Fourth level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'm', 'Alternative numbering scheme, chronology', 'Alternative numbering scheme, chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'n', 'Pattern note', 'Pattern note', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'p', 'Number of pieces per issuance', 'Number of pieces per issuance', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 't', 'Copy', 'Copy', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'u', 'Bibliographic units per next higher level', 'Bibliographic units per next higher level', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'v', 'Numbering continuity', 'Numbering continuity', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'w', 'Frequency', 'Frequency', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'x', 'Calendar change', 'Calendar change', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'y', 'Regularity pattern', 'Regularity pattern', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('853', 'z', 'Numbering scheme', 'Numbering scheme', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'a', 'First level of enumeration', 'First level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'b', 'Second level of enumeration', 'Second level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'c', 'Third level of enumeration', 'Third level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'd', 'Fourth level of enumeration', 'Fourth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'e', 'Fifth level of enumeration', 'Fifth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'f', 'Sixth level of enumeration', 'Sixth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'g', 'Alternative numbering scheme, first level of enumeration', 'Alternative numbering scheme, first level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'h', 'Alternative numbering scheme, second level of enumeration', 'Alternative numbering scheme, second level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'i', 'First level of chronology', 'First level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'j', 'Second level of chronology', 'Second level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'k', 'Third level of chronology', 'Third level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'l', 'Fourth level of chronology', 'Fourth level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'm', 'Alternative numbering scheme, chronology', 'Alternative numbering scheme, chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'n', 'Pattern note', 'Pattern note', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'p', 'Number of pieces per issuance', 'Number of pieces per issuance', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 't', 'Copy', 'Copy', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'u', 'Bibliographic units per next higher level', 'Bibliographic units per next higher level', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'v', 'Numbering continuity', 'Numbering continuity', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'w', 'Frequency', 'Frequency', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'x', 'Calendar change', 'Calendar change', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'y', 'Regularity pattern', 'Regularity pattern', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('854', 'z', 'Numbering scheme', 'Numbering scheme', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'a', 'First level of enumeration', 'First level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'b', 'Second level of enumeration', 'Second level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'c', 'Third level of enumeration', 'Third level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'd', 'Fourth level of enumeration', 'Fourth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'e', 'Fifth level of enumeration', 'Fifth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'f', 'Sixth level of enumeration', 'Sixth level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'g', 'Alternative numbering scheme, first level of enumeration', 'Alternative numbering scheme, first level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'h', 'Alternative numbering scheme, second level of enumeration', 'Alternative numbering scheme, second level of enumeration', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'i', 'First level of chronology', 'First level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'j', 'Second level of chronology', 'Second level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'k', 'Third level of chronology', 'Third level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'l', 'Fourth level of chronology', 'Fourth level of chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'm', 'Alternative numbering scheme, chronology', 'Alternative numbering scheme, chronology', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'n', 'Pattern note', 'Pattern note', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'p', 'Number of pieces per issuance', 'Number of pieces per issuance', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 't', 'Copy', 'Copy', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'u', 'Bibliographic units per next higher level', 'Bibliographic units per next higher level', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'v', 'Numbering continuity', 'Numbering continuity', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'w', 'Frequency', 'Frequency', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'x', 'Calendar change', 'Calendar change', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'y', 'Regularity pattern', 'Regularity pattern', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('855', 'z', 'Numbering scheme', 'Numbering scheme', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', '2', 'Access method', 'Access method', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'a', 'Host name', 'Host name', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'b', 'Access number', 'Access number', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'c', 'Compression information', 'Compression information', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'd', 'Path', 'Path', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'f', 'Electronic name', 'Electronic name', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'h', 'Processor of request', 'Processor of request', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'i', 'Instruction', 'Instruction', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'j', 'Bits per second', 'Bits per second', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'k', 'Password', 'Password', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'l', 'Logon', 'Logon', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'm', 'Contact for access assistance', 'Contact for access assistance', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'n', 'Name of location of host in subfield', 'Name of location of host in subfield', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'o', 'Operating system', 'Operating system', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'p', 'Port', 'Port', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'q', 'Electronic format type', 'Electronic format type', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'r', 'Settings', 'Settings', 0, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 's', 'File size', 'File size', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 't', 'Terminal emulation', 'Terminal emulation', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, 'biblioitems.url', 8, '', '', '', 1, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'v', 'Hours access method available', 'Hours access method available', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'w', 'Record control number', 'Record control number', 1, 0, '', 8, '', '', '', 0, -1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', 0, 1, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'y', 'Link text', 'Link text', 1, 0, '', 8, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('856', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', 0, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'b', 'Operator\'s initials, OID (RLIN)', 'Operator\'s initials, OID (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'c', 'Cataloger\'s initials, CIN (RLIN)', 'Cataloger\'s initials, CIN (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'd', 'TDC (RLIN)', 'TDC (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'l', 'LIB (RLIN)', 'LIB (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'p', 'PRI (RLIN)', 'PRI (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'r', 'REG (RLIN)', 'REG (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'v', 'VER (RLIN)', 'VER (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('859', 'x', 'LDEL (RLIN)', 'LDEL (RLIN)', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('866', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('866', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('866', 'a', 'Textual string', 'Textual string', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('866', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('866', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('867', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('867', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('867', 'a', 'Textual string', 'Textual string', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('867', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('867', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('868', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('868', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('868', 'a', 'Textual string', 'Textual string', 0, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('868', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('868', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', '4', 'Relator code', 'Relator code', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'a', 'Personal name', 'Personal name', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'b', 'Numeration', 'Numeration', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'e', 'Relator term', 'Relator term', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'j', 'Tag and sequence number', 'Tag and sequence number', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('870', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', '4', 'Relator code', 'Relator code', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'e', 'Relator term', 'Relator term', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'j', 'Tag and sequence number', 'Tag and sequence number', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('871', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', '4', 'Relator code', 'Relator code', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'b', 'Number [OBSOLETE]', 'Number [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'j', 'Tag and sequence number', 'Tag and sequence number', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('872', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'j', 'Tag and sequence number', 'Tag and sequence number', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('873', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', '8', 'Sequence number', 'Sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'a', 'Internal item number', 'Internal item number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'b', 'Invalid or canceled internal item number', 'Invalid or canceled internal item number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'c', 'Cost', 'Cost', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'd', 'Date acquired', 'Date acquired', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'e', 'Source of acquisition', 'Source of acquisition', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'h', 'Use restrictions', 'Use restrictions', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'j', 'Item status', 'Item status', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'l', 'Temporary location', 'Temporary location', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'p', 'Piece designation', 'Piece designation', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'r', 'Invalid or canceled piece designation', 'Invalid or canceled piece designation', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 't', 'Copy number', 'Copy number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('876', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', '8', 'Sequence number', 'Sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'a', 'Internal item number', 'Internal item number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'b', 'Invalid or canceled internal item number', 'Invalid or canceled internal item number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'c', 'Cost', 'Cost', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'd', 'Date acquired', 'Date acquired', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'e', 'Source of acquisition', 'Source of acquisition', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'h', 'Use restrictions', 'Use restrictions', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'j', 'Item status', 'Item status', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'l', 'Temporary location', 'Temporary location', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'p', 'Piece designation', 'Piece designation', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'r', 'Invalid or canceled piece designation', 'Invalid or canceled piece designation', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 't', 'Copy number', 'Copy number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('877', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', '3', 'Materials specified', 'Materials specified', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', '8', 'Sequence number', 'Sequence number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'a', 'Internal item number', 'Internal item number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'b', 'Invalid or canceled internal item number', 'Invalid or canceled internal item number', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'c', 'Cost', 'Cost', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'd', 'Date acquired', 'Date acquired', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'e', 'Source of acquisition', 'Source of acquisition', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'h', 'Use restrictions', 'Use restrictions', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'j', 'Item status', 'Item status', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'l', 'Temporary location', 'Temporary location', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'p', 'Piece designation', 'Piece designation', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'r', 'Invalid or canceled piece designation', 'Invalid or canceled piece designation', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 't', 'Copy number', 'Copy number', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('878', 'z', 'Public note', 'Public note', 1, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '2', '2', '2', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '3', '3', '3', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '4', '4', '4', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '5', '5', '5', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '7', '7', '7', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '8', '8', '8', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', '9', '9', '9', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'a', 'a', 'a', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'b', 'b', 'b', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'c', 'c', 'c', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'd', 'd', 'd', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'e', 'e', 'e', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'f', 'f', 'f', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'g', 'g', 'g', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'h', 'h', 'h', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'i', 'i', 'i', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'j', 'j', 'j', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'k', 'k', 'k', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'l', 'l', 'l', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'm', 'm', 'm', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'n', 'n', 'n', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'o', 'o', 'o', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'p', 'p', 'p', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'q', 'q', 'q', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'r', 'r', 'r', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 's', 's', 's', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 't', 't', 't', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'u', 'u', 'u', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'v', 'v', 'v', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'w', 'w', 'w', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'x', 'x', 'x', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'y', 'y', 'y', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('880', 'z', 'z', 'z', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '0', '0', '0', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '1', '1', '1', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '2', '2', '2', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '3', '3', '3', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '4', '4', '4', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '5', '5', '5', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '6', '6', '6', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '7', '7', '7', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '8', '8', '8', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', '9', '9', '9', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'a', 'a', 'a', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'b', 'b', 'b', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'c', 'c', 'c', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'd', 'd', 'd', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'e', 'e', 'e', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'f', 'f', 'f', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'g', 'g', 'g', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'h', 'h', 'h', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'i', 'i', 'i', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'j', 'j', 'j', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'k', 'k', 'k', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'l', 'l', 'l', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'm', 'm', 'm', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'n', 'n', 'n', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'o', 'o', 'o', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'p', 'p', 'p', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'q', 'q', 'q', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'r', 'r', 'r', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 's', 's', 's', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 't', 't', 't', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'u', 'u', 'u', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'v', 'v', 'v', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'w', 'w', 'w', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'x', 'x', 'x', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'y', 'y', 'y', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('886', 'z', 'z', 'z', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('887', '2', 'Source of data', 'Source of data', 0, 0, NULL, 8, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('887', 'a', 'Content of non-MARC field', 'Content of non-MARC field', 0, 0, NULL, 8, NULL, NULL, '', NULL, 0, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', '4', 'Relator code', 'Relator code', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'a', 'Personal name', 'Personal name', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'b', 'Numeration', 'Numeration', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'e', 'Relator term', 'Relator term', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('896', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', '4', 'Relator code', 'Relator code', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'e', 'Relator term', 'Relator term', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('897', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', '4', 'Relator code', 'Relator code', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', '8', 'Field link and sequence number ', 'Field link and sequence number ', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'b', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'h', 'Medium', 'Medium', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 's', 'Version', 'Version', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('898', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', '%', '% (RLIN)', '% (RLIN)', 0, 0, '', 8, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', '6', 'Linkage', 'Linkage', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', '9', '9 (RLIN)', '9 (RLIN)', 0, 0, '', 8, '', '', '', 0, -5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'h', 'Medium', 'Medium', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'r', 'Key for music', 'Key for music', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 's', 'Version', 'Version', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 't', 'Title of a work', 'Title of a work', 0, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('899', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 8, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '0', '0', '0', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '1', '1', '1', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '2', '2', '2', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '3', '3', '3', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '4', '4', '4', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '5', '5', '5', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '6', '6', '6', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '7', '7', '7', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '8', '8', '8', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', '9', '9', '9', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'a', 'a', 'a', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'b', 'b', 'b', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'c', 'c', 'c', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'd', 'd', 'd', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'e', 'e', 'e', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'f', 'f', 'f', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'g', 'g', 'g', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'h', 'h', 'h', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'i', 'i', 'i', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'j', 'j', 'j', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'k', 'k', 'k', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'l', 'l', 'l', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'm', 'm', 'm', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'n', 'n', 'n', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'o', 'o', 'o', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'p', 'p', 'p', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'q', 'q', 'q', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'r', 'r', 'r', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 's', 's', 's', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 't', 't', 't', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'u', 'u', 'u', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'v', 'v', 'v', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'w', 'w', 'w', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'x', 'x', 'x', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'y', 'y', 'y', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('89e', 'z', 'z', 'z', 1, 0, '', 8, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', '4', 'Relator code', 'Relator code', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'a', 'Personal name', 'Personal name', 0, 0, '', 9, '', '', '', 0, 5, '', '''110a'', ''700a'', ''710a''', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'b', 'Numeration', 'Numeration', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'e', 'Relator term', 'Relator term', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 't', 'Title of a work', 'Title of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('900', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('901', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('902', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('903', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('904', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('905', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('906', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('907', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('908', 'a', 'Put command parameter', 'Put command parameter', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', '4', 'Relator code', 'Relator code', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'e', 'Relator term', 'Relator term', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 't', 'Title of a work', 'Title of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('910', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('91o', 'a', 'User-option data', 'User-option data', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('91r', 'a', 'RLG standards note', 'RLG standards note', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', '4', 'Relator code', 'Relator code', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', '6', 'Linkage', 'Linkage', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'b', 'Number [OBSOLETE]', 'Number [OBSOLETE]', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('911', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', '6', 'Linkage', 'Linkage', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'a', 'Uniform title', 'Uniform title', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'h', 'Medium', 'Medium', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 'r', 'Key for music', 'Key for music', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 's', 'Version', 'Version', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('930', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'a', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'b', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'c', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'd', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'e', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'f', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'g', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'h', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'i', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('93r', 'k', 'SHS', 'SHS', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('936', 'a', 'OCLC control number(s) of parallel record(s) (OCLC); Piece used for cataloging, PUC (RLIN)', 'OCLC control number(s) of parallel record(s) (OCLC); Piece used for cataloging, PUC (RLIN)', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 9, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'h', 'Medium', 'Medium', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 'r', 'Key for music', 'Key for music', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('940', 's', 'Version', 'Version', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('941', 'a', 'Romanized title', 'Romanized title', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('941', 'h', 'Medium', 'Medium', 0, 0, NULL, 9, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'a', 'Uniform title', 'Unifor title', 0, 0, '', 9, '', '', '', 1, 5, '', '', '130');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'h', 'Medium', 'Medium', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 'r', 'Key for music', 'Key for music', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('943', 's', 'Version', 'Version', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('945', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'a', 'Title', 'Title', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'b', 'Remainder of title', 'Remainder of title', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'c', 'Statement of responsibility, etc', 'Statement of responsibility, etc', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'd', 'Designation of section/part/series (SE) [OBSOLETE]', 'Designation of section section/part/series (SE) [OBSOLETE]', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'e', 'Name of part/section/series (SE) [OBSOLETE]', 'Name of part/section/series (SE) [OBSOLETE]', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'f', 'Inclusive dates', 'Inclusive dates', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'g', 'Bulk dates', 'Bulk dates', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'h', 'Medium', 'Medium', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'k', 'Form', 'Form', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94c', 's', 'Version', 'Version', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('946', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('947', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '0', '0 (OCLC)', '0 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '1', '1 (OCLC)', '1 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '2', '2 (OCLC)', '2 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '3', '3 (OCLC)', '3 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '4', '4 (OCLC)', '4 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '5', '5 (OCLC)', '5 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '6', '6 (OCLC)', '6 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '7', '7 (OCLC)', '7 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '8', '8 (OCLC)', '8 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', '9', '9 (OCLC)', '9 (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'a', 'Series part designator, SPT (RLIN)', 'Series part designator, SPT (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'b', 'b (OCLC)', 'b (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'c', 'c (OCLC)', 'c (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'd', 'd (OCLC)', 'd (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'e', 'e (OCLC)', 'e (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'f', 'f (OCLC)', 'f (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'g', 'g (OCLC)', 'g (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'h', 'h (OCLC)', 'h (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'i', 'i (OCLC)', 'i (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'j', 'j (OCLC)', 'j (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'k', 'k (OCLC)', 'k (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'l', 'l (OCLC)', 'l (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'm', 'm (OCLC)', 'm (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'n', 'n (OCLC)', 'n (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'o', 'o (OCLC)', 'o (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'p', 'p (OCLC)', 'p (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'q', 'q (OCLC)', 'q (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'r', 'r (OCLC)', 'r (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 's', 's (OCLC)', 's (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 't', 't (OCLC)', 't (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'u', 'u (OCLC)', 'u (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'v', 'v (OCLC)', 'v (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'w', 'w (OCLC)', 'w (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'x', 'x (OCLC)', 'x (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'y', 'y (OCLC)', 'y (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('948', 'z', 'z (OCLC)', 'z (OCLC)', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '0', '0', '0', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '1', '1', '1', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '2', '2', '2', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '3', '3', '3', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '4', '4', '4', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '5', '5', '5', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '6', '6', '6', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '7', '7', '7', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '8', '8', '8', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', '9', '9', '9', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'a', 'a', 'a', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'b', 'b', 'b', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'c', 'c', 'c', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'd', 'd', 'd', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'e', 'e', 'e', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'f', 'f', 'f', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'g', 'g', 'g', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'h', 'h', 'h', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'i', 'i', 'i', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'j', 'j', 'j', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'k', 'k', 'k', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'l', 'l', 'l', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'm', 'm', 'm', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'n', 'n', 'n', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'o', 'o', 'o', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'p', 'p', 'p', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'q', 'q', 'q', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'r', 'r', 'r', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 's', 's', 's', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 't', 't', 't', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'u', 'u', 'u', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'v', 'v', 'v', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'w', 'w', 'w', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'x', 'x', 'x', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'y', 'y', 'y', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('949', 'z', 'z', 'z', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94a', 'a', 'ATN', 'ATN', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94a', 'b', 'ATN', 'ATN', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94a', 'c', 'ATN', 'ATN', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94a', 'd', 'ATN', 'ATN', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94a', 'e', 'ATN', 'ATN', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94b', 'a', 'ATC', 'ATC', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('94b', 'b', 'SNR', 'SNR', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'a', 'Classification number, LCAL (RLIN)', 'Classification number, LCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'b', 'Book number/undivided call number, LCAL (RLIN)', 'Book number/undivided call number, LCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'd', 'Additional free-text stamp above the call number, LCAL (RLIN)', 'Additional free-text stamp above the call number, LCAL (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'e', 'Additional free-text or profiled stamp below the call number, LCAL (RLIN)', 'Additional free-text or profiled stamp below the call number, LCAL (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'f', 'Location-level footnote, LFNT (RLIN)', 'Location-level footnote, LFNT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'h', 'Location-level output transaction history, LHST (RLIN)', 'Location-level output transaction history, LHST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'i', 'Location-level extra card request, LEXT (RLIN)', 'Location-level extra card request, LEXT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'l', 'Permanent shelving location, LOC (RLIN)', 'Permanent shelving location, LOC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'n', 'Location-level additional note, LANT (RLIN)', 'Location-level additional note, LANT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'p', 'Location-level pathfinder, LPTH (RLIN)', 'Location-level pathfinder, LPTH (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 't', 'Location-level field suppression, LFSP (RLIN)', 'Location-level field suppression, LFSP (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'u', 'Non-printing notes, LANT (RLIN)', 'Non-printing notes, LANT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'v', 'Volumes, LVOL (RLIN)', 'Volumes, LVOL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'w', 'Subscription status code, LANT (RLIN)', 'Subscription status code, LANT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'y', 'Date, LVOL (RLIN)', 'Date, LVOL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('950', 'z', 'Retention, LVOL (RLIN)', 'Retention, LVOL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', '2', 'Source of heading or term', 'Source of heading or term', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', '3', 'Materials specified', 'Materials specified', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', '6', 'Linkage', 'Linkage', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', 'a', 'Geographic name', 'Geographic name', 0, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', 'b', 'Geographic name following place entry element [OBSOLETE]', 'Geographic name following place entry element [OBSOLETE]', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', 'v', 'Form subdivision', 'Form subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', 'x', 'General subdivision', 'General subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', 'y', 'Chronological subdivision', 'Chronological subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('951', 'z', 'Geographic subdivision', 'Geographic subdivision', 1, 0, '', 6, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95c', 'a', 'Record ID (RLIN)', 'Record ID (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95c', 'b', 'Institution name (RLIN)', 'Institution name (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95r', '6', 'Linkage', 'Linkage', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95r', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95r', 'a', 'Country', 'Country', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95r', 'b', 'State, province, territory', 'State, province, territory', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95r', 'c', 'County, region, islands area', 'County, region, islands area', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('95r', 'd', 'City', 'City', 0, 0, NULL, 9, NULL, NULL, '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'a', 'Classification number, CCAL (RLIN)', 'Classification number, CCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'b', 'Book number/undivided call number, CCAL (RLIN)', 'Book number/undivided call number, CCAL (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'c', 'Copy information and material description, CCAL + MDES (RLIN)', 'Copy information and material description, CCAL + MDES (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'h', 'Copy status--for earlier dates, CST (RLIN)', 'Copy status--for earlier dates, CST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'i', 'Copy status, CST (RLIN)', 'Copy status, CST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'l', 'Permanent shelving location, LOC (RLIN)', 'Permanent shelving location, LOC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'q', 'Aquisitions control number, HNT (RLIN)', 'Aquisitions control number, HNT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'r', 'Circulation control number, HNT (RLIN)', 'Circulation control number, HNT (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 's', 'Shelflist note, HNT (RLIN)', 'Shelflist note, HNT (RLIN)', 1, 0, '', 9, '', '', '', 1, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('955', 'u', 'Non-printing notes, HNT (RLIN)', 'Non-printing notes, HNT (RLIN)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', '2', 'Access method', 'Access method', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', '3', 'Materials specified', 'Materials specified', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'a', 'Host name', 'Host name', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'b', 'Access number', 'Access number', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'c', 'Compression information', 'Compression information', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'd', 'Path', 'Path', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'f', 'Electronic name', 'Electronic name', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'h', 'Processor of request', 'Processor of request', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'i', 'Instruction', 'Instruction', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'j', 'Bits per second', 'Bits per second', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'k', 'Password', 'Password', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'l', 'Logon', 'Logon', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'm', 'Contact for access assistance', 'Contact for access assistance', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'n', 'Name of location of host in subfield', 'Name of location of host in subfield', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'o', 'Operating system', 'Operating system', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'p', 'Port', 'Port', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'q', 'Electronic format type', 'Electronic format type', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'r', 'Settings', 'Settings', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 's', 'File size', 'File size', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 't', 'Terminal emulation', 'Terminal emulation', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'u', 'Uniform Resource Identifier', 'Uniform Resource Identifier', 1, 0, '', 9, '', '', '', 1, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'v', 'Hours access method available', 'Hours access method available', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'w', 'Record control number', 'Record control number', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'x', 'Nonpublic note', 'Nonpublic note', 1, 0, '', 9, '', '', '', 0, 6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'y', 'Link text', 'Link text', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('956', 'z', 'Public note', 'Public note', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('960', '3', 'Materials specified, MATL', 'Materials specified, MATL', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('960', 'a', 'Physical location, PLOC (RLIN)', 'Physical location, PLOC (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('967', 'a', 'GNR (RLIN)', 'GNR (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('967', 'c', 'PSI (RLIN)', 'PSI (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', '4', 'Relator code', 'Relator code', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'a', 'Personal name', 'Personal name', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'b', 'Numeration', 'Numeration', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'c', 'Titles and other words associated with a name', 'Titles and other words associated with a name', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'd', 'Dates associated with a name', 'Dates associated with a name', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'e', 'Relator term', 'Relator term', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'h', 'Medium', 'Medium', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'j', 'Attribution qualifier', 'Attribution qualifier', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'q', 'Fuller form of name', 'Fuller form of name', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'r', 'Key for music', 'Key for music', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 's', 'Version', 'Version', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 't', 'Title of a work', 'Title of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('980', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', '4', 'Relator code', 'Relator code', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'a', 'Corporate name or jurisdiction name as entry element', 'Corporate name or jurisdiction name as entry element', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'b', 'Subordinate unit', 'Subordinate unit', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'c', 'Location of meeting', 'Location of meeting', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'd', 'Date of meeting or treaty signing', 'Date of meeting or treaty signing', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'e', 'Relator term', 'Relator term', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'h', 'Medium', 'Medium', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'r', 'Key for music', 'Key for music', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 's', 'Version', 'Version', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 't', 'Title of a work', 'Title of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'u', 'Affiliation', 'Affiliation', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('981', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', '4', 'Relator code', 'Relator code', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', '6', 'Linkage', 'Linkage', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', '8', 'Field link and sequence number ', 'Field link and sequence number ', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'a', 'Meeting name or jurisdiction name as entry element', 'Meeting name or jurisdiction name as entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'b', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 'Number (BK CF MP MU SE VM MX) [OBSOLETE]', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'c', 'Location of meeting', 'Location of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'd', 'Date of meeting', 'Date of meeting', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'e', 'Subordinate unit', 'Subordinate unit', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'f', 'Date of a work', 'Date of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'h', 'Medium', 'Medium', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'k', 'Form subheading', 'Form subheading', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'l', 'Language of a work', 'Language of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'n', 'Number of part/section/meeting', 'Number of part/section/meeting', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'q', 'Name of meeting following jurisdiction name entry element', 'Name of meeting following jurisdiction name entry element', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 's', 'Version', 'Version', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 't', 'Title of a work', 'Title of a work', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'u', 'Affiliation', 'Affiliation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('982', 'v', 'Volume/sequential designation', 'Volume/sequential designation', 0, 0, NULL, 8, NULL, NULL, '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', '6', 'Linkage', 'Linkage', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', '8', 'Field link and sequence number', 'Field link and sequence number', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'a', 'Uniform title', 'Uniform title', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'd', 'Date of treaty signing', 'Date of treaty signing', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'f', 'Date of a work', 'Date of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'g', 'Miscellaneous information', 'Miscellaneous information', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'h', 'Medium', 'Medium', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'k', 'Form subheading', 'Form subheading', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'l', 'Language of a work', 'Language of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'm', 'Medium of performance for music', 'Medium of performance for music', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'n', 'Number of part/section of a work', 'Number of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'o', 'Arranged statement for music', 'Arranged statement for music', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'p', 'Name of part/section of a work', 'Name of part/section of a work', 1, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'r', 'Key for music', 'Key for music', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 's', 'Version', 'Version', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 't', 'Title of a work', 'Title of a work', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('983', 'v', 'Volume number/sequential designation', 'Volume number/sequential designation', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'a', 'Holding library identification number', 'Holding library identification number', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'b', 'Physical description codes', 'Physical description codes', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'c', 'Call number', 'Call number', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'd', 'Volume or other numbering', 'Volume or other numbering', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'e', 'Dates', 'Dates', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'f', 'Completeness note', 'Completeness note', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'g', 'Referral note', 'Referral note', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('984', 'h', 'Retention note', 'Retention note', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('987', 'a', 'Romanization/conversion identifier', 'Romanization/conversion identifier', 0, 0, '', 9, '', '', '', NULL, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('987', 'b', 'Agency that converted, created or reviewed', 'Agency that converted, created or reviewed', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('987', 'c', 'Date of conversion or review', 'Date of conversion or review', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('987', 'd', 'Status code', 'Status code ', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('987', 'e', 'Version of conversion program used', 'Version of conversion program used', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('987', 'f', 'Note', 'Note', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('990', 'a', 'Link information for 9XX fields', 'Link information for 9XX fields', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('990', 'b', 'Link information for field corresponding to 9XX field', 'Link information for field corresponding to 9XX field', 1, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'a', 'Origine du document, texte libre', 'Origine du document, texte libre', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'b', 'Origine du document, donn&eacute;e cod&eacute;e', '', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'c', '&Eacute;tablissement pr&ecirc;teur ou d&eacute;posant, texte libre', '&Eacute;tablissement pr&ecirc;teur ou d&eacute;posant, texte libre', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'd', '&Eacute;tablissement pr&ecirc;teur ou d&eacute;posant, donn&eacute;e cod&eacute;e', '&Eacute;tablissement pr&ecirc;teur ou d&eacute;posant, donn&eacute;e cod&eacute;e', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'e', 'Genre d&eacute;taill&eacute;', 'Genre d&eacute;taill&eacute;', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'f', 'Code &agrave; barres, suite alphanum&eacute;rique int&eacute;grale', 'Code &agrave; barres, suite alphanum&eacute;rique int&eacute;grale', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'g', 'Code &agrave; barres, pr&eacute;fixe', 'Code &agrave; barres, pr&eacute;fixe', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'h', 'Code &agrave; barres, incr&eacute;mentation', 'Code &agrave; barres, incr&eacute;mentation', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'i', 'Code &agrave; barres, suffixe', 'Code &agrave; barres, suffixe', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'j', '&Eacute;tablissement pr&ecirc;teur ou d&eacute;posant, donn&eacute;e cod&eacute;e', '&Eacute;tablissement pr&ecirc;teur ou d&eacute;posant, donn&eacute;e cod&eacute;e', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'k', 'Cote', 'Cote', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'l', 'Volumaison', 'Volumaison', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'm', 'Date de pr&ecirc;t ou de d&eacute;p&ocirc;t', 'Date de pr&ecirc;t ou de d&eacute;p&ocirc;t', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'n', 'Date de restitution pr&eacute;vue', 'Date de restitution pr&eacute;vue', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'o', 'Cat&eacute;gorie de circulation', 'Cat&eacute;gorie de circulation', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'p', 'P&eacute;riodique', 'P&eacute;riodique', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'q', 'Public vis&eacute; (selon l\'&acirc;ge)', 'Public vis&eacute; (selon l\'&acirc;ge)', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'r', 'Type de document et support mat&eacute;riel', 'Type de document et support mat&eacute;riel', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 's', 'l&eacute;ment de tri', 'l&eacute;ment de tri', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 't', 'Genre', 'Genre', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'u', 'Note sur l\'exemplaire', 'Note sur l\'exemplaire', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'v', 'Note sur le num&eacute;ro de p&eacute;riodique', 'Note sur le num&eacute;ro de p&eacute;riodique', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'w', 'tablissement cible du document, texte libre', 'tablissement cible du document, texte libre', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'x', '&Eacute;tablissement cible du document, donn&eacute;e cod&eacute;e', '&Eacute;tablissement cible du document, donn&eacute;e cod&eacute;e', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'y', 'Ensemble cible du document , texte libre', 'Ensemble cible du document, texte libre', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('995', 'z', 'Ensemble cible du document, donn&eacute;e cod&eacute;e', 'Ensemble cible du document, donn&eacute;e cod&eacute;e', 0, 0, '', 9, '', '', '', NULL, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'b', 'Operator\'s initials, OID (RLIN)', 'Operator\'s initials, OID (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'c', 'Cataloger\'s initials, CIN (RLIN)', 'Cataloger\'s initials, CIN (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'd', 'First date, FD (RLIN)', 'First Date, FD (RLIN)', 0, 0, '', 9, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'i', 'RINS (RLIN)', 'RINS (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'l', 'LI (RLIN)', 'LI (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'n', 'NUC (RLIN)', 'NUC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'p', 'PROC (RLIN)', 'PROC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 's', 'CC (RLIN)', 'CC (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 't', 'RTYP (RLIN)', 'RTYP (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('998', 'w', 'PLINK (RLIN)', 'PLINK (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'a', 'Classification number (OCLC) (R) ; Classification number, CALL (RLIN) (NR)', 'Classification number (OCLC) (R) ; Classification number, CALL (RLIN) (NR)', 1, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'b', 'Local cutter number (OCLC) ; Book number/undivided call number, CALL (RLIN)', 'Local cutter number (OCLC) ; Book number/undivided call number, CALL (RLIN)', 0, 0, '', 0, '', '', '', 0, -6, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'e', 'Feature heading (OCLC)', 'Feature heading (OCLC)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'f', 'Filing suffix (OCLC); Footnote, FNT (RLIN)', 'Filing suffix (OCLC); Footnote, FNT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'h', 'Output transaction history, HST (RLIN)', 'Output transaction history, HST (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'i', 'Output transaction instruction, INS (RLIN)', 'Output transaction instruction, INS (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'l', 'Extra card control statement, EXT (RLIN)', 'Extra card control statement, EXT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'n', 'Additional local notes, ANT (RLIN)', 'Additional local notes, ANT (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'p', 'Pathfinder code, PTH (RLIN)', 'Pathfinder code, PTH (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 't', 'Field suppresion, FSP (RLIN)', 'Field suppresion, FSP (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'v', 'Volumes, VOL (RLIN)', 'Volumes, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'y', 'Date, VOL (RLIN)', 'Date, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('999', 'z', 'Retention, VOL (RLIN)', 'Retention, VOL (RLIN)', 0, 0, '', 0, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 'a', 'Operator\'s initials, OID (RLIN)', 'Operator\'s initials, OID (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 'd', 'UAD (RLIN)', 'UAD (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 'f', 'FPST (RLIN)', 'FPST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 'h', 'CPST (RLIN)', 'FPST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 'i', 'CPST (RLIN)', 'FPST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 's', 'UST (RLIN)', 'UST (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u01', 't', 'UTYP (RLIN)', 'UTYP (RLIN)', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u02', '2', 'Source of number or code', 'Source of number or code', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u02', 'a', 'Standard number or code', 'Standard number or code', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u02', 'b', 'Additional codes following the standard number', 'Additional codes following the standard number', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u02', 'c', 'Terms of availability', 'Terms of availability', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u02', 'z', 'Canceled/invalid standard number or code', 'Canceled/invalid standard number or code', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u08', 'n', 'LSI', 'LSI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u08', 'o', 'SID', 'SID', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u08', 'p', 'DP', 'DP', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u08', 'r', 'RUSH', 'RUSH', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u10', 'a', 'REQ', 'REQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u10', 'b', 'SID', 'REQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u10', 'c', 'REQ', 'REQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u10', 'd', 'REQ', 'REQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u10', 'e', 'REQ', 'REQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u10', 's', 'REQ', 'REQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u11', 'a', 'Department report request, DRR (DRRH for earlier occurrences)', 'DRR (DRRH for earlier occurrences)', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u20', 'a', 'SUPN', 'SUPN', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u20', 'b', 'SUPN', 'SUPN', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u20', 'c', 'SUPN', 'SUPN', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u20', 'd', 'SUPN', 'SUPN', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u20', 'e', 'SUPN', 'SUPN', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u20', 'x', 'SUPN', 'SUPN', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u21', 'a', 'SHIP', 'SHIP', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u21', 'b', 'BILL', 'BILL', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u21', 'c', 'DAC', 'DAC', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u21', 'n', 'LSAC', 'LSAC', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u22', 'a', 'SICO', 'SICO', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u22', 'b', 'SICO', 'SICO', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u22', 'c', 'SCAT', 'SCAT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u25', 'a', 'Supplier report(s), SRPT', 'Supplier report(s), SRPT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u30', 'a', 'NCC [OBSOLETE]', 'NCC [OBSOLETE]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u30', 'i', 'ICI', 'ICI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u30', 'm', 'MCI', 'MCI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u31', 'a', 'NCC', 'NCC', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u31', 'b', 'NCS', 'NCS', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u33', 'a', 'ICL', 'ICL', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u33', 'd', 'ICAD', 'ICAD', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u34', 'a', 'EPCL', 'EPCL', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u34', 'r', 'ERI', 'ERI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u40', 'd', 'EPDT [OBSOLETE]', 'EPDT [OBSOLETE]', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u40', 'f', 'EFRQ', 'EFRQ', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u40', 's', 'EPST', 'EPST', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u40', 't', 'ETYP', 'ETYP', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u50', 'a', 'Acquisitions notes, AQNT', 'Acquisitions notes, AQNT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u51', 'a', 'Selection notes, SLNT', 'Selection notes, SLNT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u52', 'a', 'INT', 'INT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u52', 'b', 'INT', 'NT', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u53', 'a', 'CLNT', 'CLNT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u53', 'b', 'CLNT', 'CLNT', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u54', 'a', 'Notes to serials department, SRNT', 'Notes to serials department, SRNT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u55', 'a', 'Cataloging notes, CTNT', 'Cataloging notes, CTNT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u5f', 'a', 'Accounting notes, ACNT', 'Accounting notes, ACNT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u70', 'a', 'QTY', 'QTY', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u70', 'b', 'MAT', 'MAT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u70', 'l', 'MLOC', 'MLOC', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u71', 'a', 'Fund account, FUND', 'Fund account, FUND', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u75', 'a', 'ITEM', 'ITEM', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u75', 'c', 'CIRC', 'CIRC', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u75', 'h', 'IPST', 'IPST', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u75', 'i', 'ITEM', 'ITEM', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u75', 'l', 'SLOC', 'SLOC', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u7f', 'a', 'LPRI', 'LPRI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u7f', 'b', 'CURR', 'CURR', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u7f', 'k', 'CVRT [OBSOLETE]', 'CVRT [OBSOLETE]', 1, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u7f', 'p', 'LPD', 'LPD', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u7f', 'r', 'EDRT', 'EDRT', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u90', 'h', 'TAPE', 'TAPE', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('u90', 'i', 'TAPE', 'TAPE', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'a', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'b', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'c', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'd', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'e', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'f', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'g', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'h', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');
INSERT INTO `marc_subfield_structure` VALUES ('ufi', 'n', 'FI', 'FI', 0, 0, '', 9, '', '', '', 0, 5, '', '', '');

